SystemOrganization addCategory: #'RobotSoccer-Model'!
SystemOrganization addCategory: #'RobotSoccer-Tests'!
SystemOrganization addCategory: #'RobotSoccer-Viewer-Plugins'!
SystemOrganization addCategory: #'RobotSoccer-Viewer'!
SystemOrganization addCategory: #'RobotSoccer-Strategy-Performance'!
SystemOrganization addCategory: #'RobotSoccer-Strategy-Example'!
SystemOrganization addCategory: #'RobotSoccer-Servers'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Simulated'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-MixedRobots'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-LegoNxt'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-Doraemon'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Empty'!
SystemOrganization addCategory: #'RobotSoccer-Servers-Real-Nestor'!

EllipseMorph subclass: #RSBallMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSBallMorph methodsFor: 'initialize' stamp: 'Richo 10/9/2009 16:25'!
initialize
super initialize.
self extent:  10.675@10.675; color: Color orange! !

Object subclass: #RSAngle
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSAngle class methodsFor: 'instance creation' stamp: 'Richo 6/21/2008 19:57'!
degrees: aNumber 
	^ self basicNew inDegrees: aNumber! !

!RSAngle class methodsFor: 'instance creation' stamp: 'Richo 6/23/2008 11:49'!
new
self shouldNotImplement! !

!RSAngle class methodsFor: 'instance creation' stamp: 'Richo 6/21/2008 19:57'!
radians: aNumber
^self basicNew inRadians: aNumber! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
+ anAngle 
	"Suma manteniendo entre -180 y 180"
	| nuevo |
	nuevo := self degrees + anAngle degrees.
	nuevo > 180
		ifTrue: [nuevo := self degrees - (360 - anAngle degrees)].
	nuevo < -180
		ifTrue: [^ self - anAngle negated].
	^ RSAngle degrees: nuevo! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
- anAngle 
	"Resta manteniendo el valor entre -180 y 180"
	| nuevo |
	nuevo := self degrees - anAngle degrees.
	nuevo < -180
		ifTrue: [nuevo := self degrees + (360 - anAngle degrees)].
	nuevo > 180
		ifTrue: [^ self + anAngle negated].
	^ RSAngle degrees: nuevo! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
< anAngle 
	^ self degrees < anAngle degrees! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
= anAngle 
	^ self radians closeTo: anAngle radians! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
> anAngle 
	^ self degrees > anAngle degrees! !

!RSAngle methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:59'!
degrees
^value radiansToDegrees ! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/21/2008 20:01'!
diff: anAngle 
	| dif |
	dif := self - anAngle.
	^ dif degrees abs! !

!RSAngle methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:59'!
inDegrees: aNumber 
	value := aNumber degreesToRadians ! !

!RSAngle methodsFor: 'initialization' stamp: 'Richo 6/21/2008 19:58'!
inRadians: aNumber
value := aNumber! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
negated
	^ RSAngle degrees: self degrees negated! !

!RSAngle methodsFor: 'arithmetic' stamp: 'Richo 6/22/2008 22:15'!
opposite
	^ self
		+ (RSAngle degrees: 180)! !

!RSAngle methodsFor: 'copying' stamp: 'Richo 10/6/2009 12:15'!
postCopy
super postCopy.
value := value copy.! !

!RSAngle methodsFor: 'printing' stamp: 'Richo 6/23/2008 11:47'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , self degrees asString , ' degrees)'! !

!RSAngle methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:59'!
radians
	^ value! !

Object subclass: #RSBall
	instanceVariableNames: 'position founded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSBall methodsFor: 'accessing' stamp: 'Richo 11/2/2009 14:39'!
founded
^founded! !

!RSBall methodsFor: 'accessing' stamp: 'Richo 11/2/2009 14:39'!
founded: aBoolean
founded := aBoolean! !

!RSBall methodsFor: 'initialization' stamp: 'Richo 11/2/2009 14:50'!
initialize
position := 0@0.
founded := false.! !

!RSBall methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:46'!
position
^position! !

!RSBall methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:51'!
position: aPoint 
position := aPoint! !

!RSBall methodsFor: 'copying' stamp: 'Richo 11/2/2009 14:39'!
postCopy
super postCopy.
position := position copy.
founded := founded copy.! !

Object subclass: #RSBallPredictor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSBallPredictor methodsFor: 'as yet unclassified' stamp: 'Richo 10/22/2010 18:47'!
ballPositionAt: nFrame on: env 
	| dif |
	"dif := env currentBall position - env lastBall position."
	dif := env currentBall position - (env lastEnvironment ifNil: [env]) currentBall position.
	^ env currentBall position + (dif * nFrame).
	! !

Object subclass: #RSEnvironment
	instanceVariableNames: 'home opponent currentBall lastBall fieldBounds goalBounds gameState whosBall lastEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

RSEnvironment class
	instanceVariableNames: 'example'!

RSEnvironment class
	instanceVariableNames: 'example'!

!RSEnvironment class methodsFor: 'test' stamp: 'Richo 10/9/2009 16:03'!
example
^example! !

!RSEnvironment class methodsFor: 'test' stamp: 'Richo 10/9/2009 16:03'!
example: anRSEnvironment
example := anRSEnvironment ! !

!RSEnvironment class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 12:40'!
newForTeam: teamClass
	^( self basicNew initializeForTeam: teamClass)
		 initialize! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
currentBall
	"Answer the value of currentBall"

	^ currentBall! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
currentBall: anObject
	"Set the value of currentBall"

	currentBall := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
fieldBounds
	"Answer the value of fieldBounds"

	^ fieldBounds! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
fieldBounds: anObject
	"Set the value of fieldBounds"

	fieldBounds := anObject! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/27/2009 17:18'!
firstEnvironment
| last |
last := self.
[last lastEnvironment]
whileFalse: [
	last := last lastEnvironment.
	].
^last! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
gameState
	"Answer the value of gameState"

	^ gameState! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
gameState: anObject
	"Set the value of gameState"

	gameState := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
goalBounds
	"Answer the value of goalBounds"

	^ goalBounds! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
goalBounds: anObject
	"Set the value of goalBounds"

	goalBounds := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
home
	"Answer the value of home"

	^ home! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
home: anObject
	"Set the value of home"

	home := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 20:22'!
homeAt: aSmallInteger
^home at: aSmallInteger ! !

!RSEnvironment methodsFor: 'initialize' stamp: 'Richo 10/30/2009 16:59'!
ifPossiblePreserveValuesOf: oldEnvironment
| robot oldRobot cantRobots |
lastEnvironment := oldEnvironment lastEnvironment.
lastBall position: oldEnvironment lastBall position.
currentBall position: oldEnvironment currentBall position.
cantRobots := oldEnvironment home size min: home size.
1 to: cantRobots do: [:i|
	robot := self homeAt: i.
	oldRobot := oldEnvironment homeAt: i.
	robot position: oldRobot position;
		rotation: oldRobot rotation.
	].
1 to: cantRobots do: [:i|
	robot := self opponentAt: i.
	oldRobot := oldEnvironment opponentAt: i.
	robot position: oldRobot position;
		rotation: oldRobot rotation.
	].
fieldBounds := oldEnvironment fieldBounds.
goalBounds := oldEnvironment goalBounds.
gameState := oldEnvironment gameState.
whosBall := oldEnvironment whosBall.! !

!RSEnvironment methodsFor: 'initialize' stamp: 'Richo 10/30/2009 16:59'!
initialize
super initialize.
fieldBounds := goalBounds := 0@0 corner: 1@1.
gameState := 0.
whosBall := 0.! !

!RSEnvironment methodsFor: 'initialize' stamp: 'Richo 10/13/2009 12:40'!
initializeForTeam: teamClass 
	| nRobots |
	nRobots := teamClass numberOfRobots.
	home := Array new: nRobots.
	opponent := Array new: nRobots.
	1
		to: nRobots
		do: [:i | 
			home at: i put: (teamClass robotClass new environment: self).
			opponent at: i put: teamClass opponentClass new].
	currentBall := teamClass ballClass new.
	lastBall :=teamClass ballClass new.! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
lastBall
	"Answer the value of lastBall"

	^ lastBall! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
lastBall: anObject
	"Set the value of lastBall"

	lastBall := anObject! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/27/2009 17:18'!
lastEnvironment
^lastEnvironment! !

!RSEnvironment methodsFor: 'accessing mementos' stamp: 'Richo 10/27/2009 17:27'!
lastEnvironment: aSmallInteger 
| v |
v := self.
aSmallInteger timesRepeat: [v := v lastEnvironment ifNil: [^self error: 'No environment found']].
^v! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
opponent
	"Answer the value of opponent"

	^ opponent! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 18:45'!
opponent: anObject
	"Set the value of opponent"

	opponent := anObject! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 20:22'!
opponentAt: aSmallInteger

	^opponent at: aSmallInteger ! !

!RSEnvironment methodsFor: 'copying' stamp: 'Richo 10/30/2009 16:59'!
postCopy
super postCopy.
home := home collect: [:r | r copy environment: self].
opponent := opponent collect: [:r | r copy].
currentBall := currentBall copy.
lastBall := lastBall copy.
fieldBounds := fieldBounds copy.
goalBounds := goalBounds copy.
gameState := gameState copy.
whosBall := whosBall copy.! !

!RSEnvironment methodsFor: 'remembering' stamp: 'Richo 11/2/2009 14:02'!
rememberYourself
lastEnvironment := self copy.
! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
whosBall
	"Answer the value of whosBall"

	^ whosBall! !

!RSEnvironment methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:54'!
whosBall: anObject
	"Set the value of whosBall"

	whosBall := anObject! !

Object subclass: #RSGame
	instanceVariableNames: 'videoServer robotServer environment team process delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSGame class methodsFor: 'constants' stamp: 'Richo 7/14/2008 11:47'!
numberOfRobotsDefaultValue
^5! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 3/31/2009 16:04'!
environment
	"Answer the value of environment"
	^ environment! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 10/27/2009 12:23'!
initializeEnvironment
| newEnvironment |
	newEnvironment := team class environmentClass newForTeam: team class.
	environment notNil ifTrue: [
		newEnvironment ifPossiblePreserveValuesOf: environment
		].
	environment := newEnvironment.! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:42'!
isPaused
process notNil ifTrue: [^process isSuspended].
^false! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/20/2009 12:24'!
isStepping
^self isStopped not and: [self isPaused not]! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/21/2009 14:42'!
isStopped
process notNil ifTrue: [^process isTerminated].
^true
! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 7/12/2008 21:39'!
pause
process ifNotNil: [
	process suspend]! !

!RSGame methodsFor: 'actions' stamp: 'Richo 10/26/2009 23:49'!
removeAll
	self removeVideoServer.
	self removeRobotServer.
	self removeTeam! !

!RSGame methodsFor: 'actions' stamp: 'Richo 10/27/2009 12:05'!
removeRobotServer
	self stop.
	robotServer
		ifNotNil: [robotServer disconnect.
			robotServer := nil]! !

!RSGame methodsFor: 'actions' stamp: 'Richo 10/27/2009 12:12'!
removeTeam
	self stop.
	team
		ifNotNil: [team := nil]! !

!RSGame methodsFor: 'actions' stamp: 'Richo 10/27/2009 12:05'!
removeVideoServer
	self stop.
	videoServer
		ifNotNil: [videoServer disconnect.
			videoServer := nil]! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
robotServer
	"Answer the value of robotServer"

	^ robotServer! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 10/27/2009 11:03'!
robotServer: anObject
	"Set the value of robotServer"
	self removeRobotServer.
	robotServer := anObject! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/27/2009 16:44'!
start
	videoServer ifNil: [^self error: 'Video server not selected'].
	robotServer ifNil: [^self error: 'Robot server not selected'].
	team ifNil: [^self error: 'Team not selected'].
	process
		ifNotNil: [process resume.
			^ self].
	delay := (Delay forMilliseconds: 1).
	process := [[true]
				whileTrue: [self step. delay wait]]
				forkNamed: self class asString! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 10/30/2009 16:37'!
step
	videoServer storeDataOn: environment.
	team strategyFor: environment.
	robotServer sendMovesOf: environment home.
	environment rememberYourself.! !

!RSGame methodsFor: 'stepping' stamp: 'Richo 7/12/2008 22:34'!
stop
	process
		ifNotNil: [process terminate. process := nil]! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
team
	"Answer the value of team"

	^ team! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 10/27/2009 11:03'!
team: aTeam 
	"Carga el team y manda a inicializar el environment"
	self removeTeam.
	team := aTeam.	
	self initializeEnvironment! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 7/12/2008 21:41'!
videoServer
	"Answer the value of videoServer"

	^ videoServer! !

!RSGame methodsFor: 'accessing' stamp: 'Richo 10/27/2009 11:03'!
videoServer: anObject
	"Set the value of videoServer"
	self removeVideoServer.
	videoServer := anObject! !

Object subclass: #RSImagesHolder
	instanceVariableNames: 'blue yellow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:14'!
defaultBlue1
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:14'!
defaultBlue2
^(Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue3
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue4
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:15'!
defaultBlue5
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335 4278190335)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:29'!
defaultNoRobot
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294901760 4294901760 4294967295 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294967295 4294901760 4294901760 4294967295 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294967295 4294901760 4294901760 4294901760 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:16'!
defaultYellow1
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294901760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:17'!
defaultYellow2
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4286578816 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:17'!
defaultYellow3
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294952132 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:18'!
defaultYellow4
^ (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4278255360 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:18'!
defaultYellow5
^  (Form
	extent: 19@19
	depth: 32
	fromArray: #( 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4286611584 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4291085567 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040)
	offset: 0@0)! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:32'!
blueImageAt: aNumber
^blue at: aNumber ifAbsent: [self class defaultNoRobot]! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:48'!
blueImageAt: aNumber put: aForm
^blue at: aNumber put: aForm! !

!RSImagesHolder methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 12:31'!
initialize
blue := {self class defaultBlue1. 
self class defaultBlue2.
self class defaultBlue3.
self class defaultBlue4.
self class defaultBlue5.}.
yellow := {self class defaultYellow1.
self class defaultYellow2.
self class defaultYellow3.
self class defaultYellow4.
self class defaultYellow5.}! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:32'!
yellowImageAt: aNumber
^yellow at: aNumber ifAbsent: [self class defaultNoRobot]! !

!RSImagesHolder methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:48'!
yellowImageAt: aNumber put: aForm
^yellow at: aNumber put: aForm! !

Object subclass: #RSOpponentRobot
	instanceVariableNames: 'rotation position founded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 11/2/2009 15:08'!
founded
	"Answer the value of founded"

	^ founded! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 11/2/2009 15:09'!
founded: aBoolean 
	"Set the value of founded"
	founded := aBoolean! !

!RSOpponentRobot methodsFor: 'initialization' stamp: 'Richo 11/2/2009 16:15'!
initialize
	rotation := RSAngle degrees: 0.
	position := 0 @ 0.
	founded := false.! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
position
	"Answer the value of position"

	^ position! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
position: anObject
	"Set the value of position"

	position := anObject! !

!RSOpponentRobot methodsFor: 'copying' stamp: 'Richo 10/6/2009 12:15'!
postCopy
super postCopy.
rotation := rotation copy.
position := position copy.! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
rotation
	"Answer the value of rotation"

	^ rotation! !

!RSOpponentRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:52'!
rotation: anObject
	"Set the value of rotation"

	rotation := anObject! !

Object subclass: #RSRobot
	instanceVariableNames: 'environment rotation position founded velocityLeft velocityRight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSRobot methodsFor: 'accessing' stamp: 'Richo 3/31/2009 16:05'!
environment
	"Answer the value of environment"
	^ environment! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 3/31/2009 16:05'!
environment: aRSEnvironment 
	environment := aRSEnvironment! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 11/2/2009 15:08'!
founded
^founded! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 11/2/2009 15:09'!
founded: aBoolean
founded := aBoolean! !

!RSRobot methodsFor: 'initialize-release' stamp: 'Richo 11/2/2009 16:15'!
initialize
	rotation := RSAngle degrees: 0.
	position := 0 @ 0.
	founded := false.
	velocityLeft := 0.
	velocityRight := 0! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
position
	"Answer the value of position"

	^ position! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
position: anObject
	"Set the value of position"

	position := anObject! !

!RSRobot methodsFor: 'copying' stamp: 'Richo 10/6/2009 13:11'!
postCopy
super postCopy.
rotation := rotation copy.
position := position copy.
velocityLeft := velocityLeft copy.
velocityRight := velocityRight copy.
! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
rotation
	"Answer the value of rotation"

	^ rotation! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 7/5/2008 21:09'!
rotation: anObject 
	"Set the value of rotation"
rotation := anObject! !

!RSRobot methodsFor: 'printing' stamp: 'Richo 6/21/2008 19:49'!
velocityAsString	^ velocityLeft asString , ' ' , velocityRight asString! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityLeft
	"Answer the value of velocityLeft"

	^ velocityLeft! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityLeft: anObject
	"Set the value of velocityLeft"

	velocityLeft := anObject! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityRight
	"Answer the value of velocityRight"

	^ velocityRight! !

!RSRobot methodsFor: 'accessing' stamp: 'Richo 6/21/2008 19:49'!
velocityRight: anObject
	"Set the value of velocityRight"

	velocityRight := anObject! !

RSRobot subclass: #RSRobotExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Example'!

!RSRobotExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 21:59'!
beGoalkeeper
	(self position x - 90) abs > 5
		ifTrue: [^ self moveTo: 90 @ self position y].
	(self rotation
			diff: (RSAngle degrees: -90))
			> 5
		ifTrue: [^ self lookDown].
	self followBallInY! !

!RSRobotExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 22:03'!
followBallInY
	| pelotaY dif speed |
	pelotaY := self environment currentBall position y.
	dif := pelotaY - self position y.
	speed := 125.
	pelotaY < 50 & (pelotaY > 30)
		ifTrue: [dif > 1
				ifTrue: ["Esta arriba"
					^ self velocityLeft: speed negated;
						 velocityRight: speed negated].
			dif < -1
				ifTrue: ["Esta abajo"
					^ self velocityLeft: speed;
						 velocityRight: speed]].
	^ self velocityLeft: 0;
		 velocityRight: 0! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:59'!
getAngle: aPoint 
	| ang |
	(self quadrant: aPoint)
			= 1
		ifTrue: [ang := self getAngleInQuadrant1: aPoint].
	(self quadrant: aPoint)
			= 2
		ifTrue: [ang := self getAngleInQuadrant2: aPoint].
	(self quadrant: aPoint)
			= 3
		ifTrue: [ang := self getAngleInQuadrant3: aPoint].
	(self quadrant: aPoint)
			= 4
		ifTrue: [ang := self getAngleInQuadrant4: aPoint].
	^ RSAngle degrees: ang! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant1: aPoint 
	| dx dy |
	dx := (aPoint x - self position x) abs.
	dy := (aPoint y - self position y) abs.
	dx = 0
		ifTrue: [^ 90.0].
	^ (dy / dx) arcTan radiansToDegrees! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant2: aPoint 
	^ 180
		- (self getAngleInQuadrant1: aPoint)! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant3: aPoint 
	^ (self getAngleInQuadrant2: aPoint) negated! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
getAngleInQuadrant4: aPoint 
	^ (self getAngleInQuadrant1: aPoint) negated! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
isInTheRightSide: aPoint 
	| miAng miOpuesto ang |
	miAng := self rotation.
	miOpuesto := miAng opposite.
	ang := self getAngle: aPoint.
	miAng degrees > 0
		ifTrue: [^ (ang > miAng | (ang < miOpuesto)) not]
		ifFalse: [^ ang < miAng | (ang > miOpuesto)]! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
isLookingTo: aPoint 
	^ (self lookInFrontOf: aPoint)
		| (self lookBackwardsTo: aPoint)! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:57'!
lookBackwardsTo: aPoint 
	| angulo |
	angulo := self getAngle: aPoint.
	^ (self rotation opposite diff: angulo)
		< 20! !

!RSRobotExample methodsFor: 'goalkeeper' stamp: 'Richo 6/22/2008 21:58'!
lookDown
	| direccion speed |
	direccion := self position x @ (self position y - 20).
	speed := 10.
	(self isInTheRightSide: direccion)
		ifTrue: [self velocityLeft: speed;
				 velocityRight: speed negated]
		ifFalse: [self velocityLeft: speed negated;
				 velocityRight: speed]! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:58'!
lookInFrontOf: aPoint 
	| angulo |
	angulo := self getAngle: aPoint.
	^ (self rotation diff: angulo)
		< 20! !

!RSRobotExample methodsFor: 'navigation' stamp: 'Richo 6/22/2008 21:58'!
moveTo: aPoint 
	(self lookInFrontOf: aPoint)
		ifTrue: [^ self velocityLeft: 125;
				 velocityRight: 125].
	(self lookBackwardsTo: aPoint)
		ifTrue: [^ self velocityLeft: -125;
				 velocityRight: -125].
	(self isInTheRightSide: aPoint)
		ifTrue: [self velocityLeft: 125;
				 velocityRight: 50]
		ifFalse: [self velocityLeft: 50;
				 velocityRight: 125]! !

!RSRobotExample methodsFor: 'navigation' stamp: 'Richo 6/22/2008 22:01'!
moveToBall
	| posPelota |
	posPelota := self environment currentBall position.
	self position x > posPelota x
		ifTrue: [self moveTo: posPelota]
		ifFalse: [self position y < posPelota y
				ifTrue: [self moveTo: posPelota x + 10 @ (posPelota y - 10)]
				ifFalse: [self moveTo: posPelota x + 10 @ (posPelota y + 10)]]! !

!RSRobotExample methodsFor: 'calculos' stamp: 'Richo 6/22/2008 21:58'!
quadrant: aPoint 
	aPoint x >= self position x
		ifTrue: [aPoint y >= self position y
				ifTrue: [^ 1]
				ifFalse: [^ 4]]
		ifFalse: [aPoint y >= self position y
				ifTrue: [^ 2]
				ifFalse: [^ 3]]! !

Object subclass: #RSRobotServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers'!

RSRobotServer subclass: #RSEmptyRobotServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Empty'!

!RSEmptyRobotServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 17:21'!
fromUser
^self new! !

!RSEmptyRobotServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 17:21'!
disconnect
! !

!RSEmptyRobotServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 17:21'!
sendMovesOf: aCollectionOfRobots
! !

RSRobotServer subclass: #RSLegoNxtRobotServer
	instanceVariableNames: 'robots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-LegoNxt'!

!RSLegoNxtRobotServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/30/2009 17:53'!
fromUser
| robotServer existingInstances choice |
existingInstances := (RSLegoNxtMorph allInstances select: [:each | each isInWorld]) sort: [:a :b | a asString < b asString].
existingInstances isEmpty
ifFalse: [
	choice := PopUpMenu withCaption: 'Choose from:' chooseFrom: #(' new... '), (existingInstances collect: [:each|' ',  each asString , ' ']).
	choice = 0 ifTrue: [^nil].
	choice > 1
		ifTrue: [
			^(existingInstances at: choice - 1) robotServer.
			].
	].
robotServer := self new.
(RSLegoNxtMorph on: robotServer) openInHand.
^robotServer! !

!RSLegoNxtRobotServer methodsFor: 'converting' stamp: 'Richo 10/28/2009 17:41'!
adapt: aNumber
^aNumber * 100 / 125! !

!RSLegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/28/2009 17:40'!
connectRobotAt: robotNumber on: portNumber
| lego |
(robots includesKey: robotNumber ) ifFalse: [
	lego := LegoNxt new.
	lego portA plug: NxtMotor new.
	lego portC plug: NxtMotor new.
	robots at: robotNumber put: lego].
(robots at: robotNumber) connectOnPort: portNumber! !

!RSLegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:19'!
disconnect
"Para cumplir con el protocolo"
self disconnectAll! !

!RSLegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/28/2009 17:42'!
disconnectAll
robots valuesDo: [:each| [
		each portA float.
		each portC float.
		each disconnect] on: NotConnectedLego do: [] ].
robots := Dictionary new! !

!RSLegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:18'!
disconnectAt: nRobot
| robot |
robot := robots at: nRobot ifAbsent: [^self].
[robot portA float.
robot portC float.
robot disconnect] on: NotConnectedLego do: [].
robot at: nRobot put: nil
! !

!RSLegoNxtRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/28/2009 17:17'!
initialize
super initialize.
robots := Dictionary new.! !

!RSLegoNxtRobotServer methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:19'!
isConnectedAt: nRobot
| robot |
robot := robots at: nRobot ifAbsent: [^false].
^robot isConnected! !

!RSLegoNxtRobotServer methodsFor: 'sending' stamp: 'Richo 10/28/2009 17:30'!
sendMovesOf: aCollectionOfRobots
| robot lego |
1 to: aCollectionOfRobots size do: [:i|
	robot := aCollectionOfRobots at: i.
	lego := (robots at: i).
	lego portC pluggedDevice power: (self adapt: robot velocityLeft).
	lego portA pluggedDevice power: (self adapt: robot velocityRight).
	]! !

RSRobotServer subclass: #RSNestorRobotServer
	instanceVariableNames: 'socket port lastTimeSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Nestor'!

RSNestorRobotServer class
	instanceVariableNames: 'lastPort'!

RSNestorRobotServer class
	instanceVariableNames: 'lastPort'!

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
fromUser
	| port |
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.
	^ self port: port! !

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
lastPort
^lastPort ifNil: [6]! !

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:20'!
new
^self shouldNotImplement! !

!RSNestorRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:26'!
port: portNumber
lastPort := portNumber.
^(self basicNew setPort: portNumber) initialize.! !

!RSNestorRobotServer methodsFor: 'converting' stamp: 'Richo 10/27/2009 16:26'!
adapt: aVelocity
aVelocity = 0
	ifTrue: [^0].
aVelocity >= 0
		ifTrue: [^100]
		ifFalse: [^200]! !

!RSNestorRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/20/2009 11:23'!
disconnect
port close.
port := nil.! !

!RSNestorRobotServer methodsFor: 'initialize-release' stamp: 'Richo 10/27/2009 16:29'!
initialize
super initialize.
lastTimeSent := Time millisecondClockValue! !

!RSNestorRobotServer methodsFor: 'accessing' stamp: 'Richo 10/20/2009 11:23'!
isConnected
^port notNil! !

!RSNestorRobotServer methodsFor: 'printing' stamp: 'Richo 10/20/2009 11:24'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , port asString , ')'! !

!RSNestorRobotServer methodsFor: 'sending' stamp: 'Richo 10/27/2009 16:28'!
sendMovesOf: aCollectionOfRobots
| msg |
Time millisecondClockValue - lastTimeSent < 50
ifTrue: [^self].
msg := ''.
1 to: 4 do: [:i |
	msg := msg , (Character value: (self adapt: (aCollectionOfRobots at: i) velocityLeft )) asString,
	(Character value: (self adapt: (aCollectionOfRobots at: i) velocityRight )) asString,
	(Character value: 0) asString
	].
msg := msg , Character cr asString.
port nextPutAll: msg.
lastTimeSent := Time millisecondClockValue.! !

!RSNestorRobotServer methodsFor: 'private' stamp: 'Richo 10/21/2009 17:50'!
setPort: portNumber
	port := SerialPort new
			baudRate: 9600;
			parityType: 0;
			dataBits: 8;
			openPort: portNumber! !

!RSRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/14/2008 12:48'!
fromUser
	"Pide los datos necesarios al usuario y crea el objeto cargando los datos
	necesarios"
	^ self subclassResponsibility! !

!RSRobotServer methodsFor: 'as yet unclassified' stamp: 'Richo 6/23/2008 11:05'!
sendMovesOf: aCollectionOfRobots
	"Enva la velocidad de las ruedas de todos los robots"
	self subclassResponsibility! !

RSRobotServer subclass: #RSSimulatedRobotServer
	instanceVariableNames: 'socket ip port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Simulated'!

RSSimulatedRobotServer class
	instanceVariableNames: 'lastIp lastPort'!

RSSimulatedRobotServer class
	instanceVariableNames: 'lastIp lastPort'!

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
fromUser
	| ip port |
	ip := FillInTheBlank request: 'IP:' initialAnswer: self lastIp.
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.
	^ self ip: ip port: port! !

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 10/20/2009 11:18'!
ip: aString port: aSmallInteger 
lastIp := aString.
lastPort := aSmallInteger.
^ (self basicNew setIp: aString setPort: aSmallInteger) initialize! !

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
lastIp
^lastIp ifNil: ['localhost']! !

!RSSimulatedRobotServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:49'!
lastPort
^lastPort ifNil: [6363]! !

!RSSimulatedRobotServer methodsFor: 'initialize-release' stamp: 'Richo 6/22/2008 17:44'!
disconnect

	socket closeAndDestroy! !

!RSSimulatedRobotServer methodsFor: 'initialize-release' stamp: 'Richo 6/23/2008 11:07'!
initialize
	socket := Socket newUDP.! !

!RSSimulatedRobotServer methodsFor: 'printing' stamp: 'Richo 7/12/2008 23:28'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , ip , ', ' , port asString , ')'! !

!RSSimulatedRobotServer methodsFor: 'sending' stamp: 'Richo 6/26/2008 11:07'!
sendMovesOf: aCollectionOfRobots 
	| str |

	str := ''.
	aCollectionOfRobots
		do: [:r | str := str , r velocityAsString , ' '].
	socket
		sendData: str
		toHost: (NetNameResolver addressForName: ip)
		port: port! !

!RSSimulatedRobotServer methodsFor: 'private' stamp: 'Richo 6/21/2008 19:09'!
setIp: aString setPort: aSmallInteger 
ip:= aString.
port := aSmallInteger ! !

Object subclass: #RSTeam
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Model'!

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
ballClass
^RSBall! !

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
environmentClass
^RSEnvironment! !

!RSTeam class methodsFor: 'instance creation' stamp: 'Richo 10/30/2009 17:57'!
fromUser
^self new! !

!RSTeam class methodsFor: 'constants' stamp: 'Richo 10/13/2009 12:44'!
numberOfRobots
"Subclasses may override this method but they need to be careful to implement a corresponding video server and robot server. Otherwise it will not work"
^5! !

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
opponentClass
^RSOpponentRobot! !

!RSTeam class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:35'!
robotClass
^RSRobot! !

!RSTeam methodsFor: 'strategy' stamp: 'Richo 7/12/2008 21:43'!
strategyFor: anEnvironment
	self subclassResponsibility! !

RSTeam subclass: #RSTeamExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Example'!

!RSTeamExample class methodsFor: 'factory' stamp: 'Richo 10/13/2009 11:52'!
robotClass
^RSRobotExample! !

!RSTeamExample methodsFor: 'strategy' stamp: 'Richo 11/2/2009 13:55'!
strategyFor: env
env home
		do: [:r | r moveToBall].
	(env homeAt: 1) beGoalkeeper.! !

RSTeam subclass: #RSTeamPerformance
	instanceVariableNames: 'times'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Strategy-Performance'!

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:41'!
getAverage
^self getDiff average asFloat! !

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:04'!
getDiff
	| aux diff |
	aux := times first.
	diff := OrderedCollection new.
	times allButFirst
		do: [:each | 
			diff add: each - aux.
			aux := each].
	^ diff ! !

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:03'!
initialize
	super initialize.
	times := OrderedCollection new.
! !

!RSTeamPerformance methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 17:18'!
strategyFor: env 

	times add: Time millisecondClockValue.
	env home
		do: [:each | each velocityLeft: 125;
				 velocityRight: -125]! !

Object subclass: #RSVideoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers'!

RSVideoServer subclass: #RSDoraemonVideoServer
	instanceVariableNames: 'socket fieldBounds goalBounds isYellowTeam predictor'
	classVariableNames: 'LastFieldBounds LastGoalBounds LastPort'
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Doraemon'!

RSDoraemonVideoServer class
	instanceVariableNames: 'lastPort'!

RSDoraemonVideoServer class
	instanceVariableNames: 'lastPort'!

!RSDoraemonVideoServer class methodsFor: 'instance creation' stamp: 'Richo 10/30/2009 17:50'!
fromUser
| videoServer existingInstances choice |
existingInstances := (RSDoraemonMorph allInstances select: [:each | each isInWorld]) sort: [:a :b | a asString < b asString].
existingInstances isEmpty
ifFalse: [
	choice := PopUpMenu withCaption: 'Choose from:' chooseFrom: #(' new... '), (existingInstances collect: [:each|' ',  each asString , ' ']).
	choice = 0 ifTrue: [^nil].
	choice > 1
		ifTrue: [
			^(existingInstances at: choice - 1) videoServer.
			].
	].
videoServer := self new.
(RSDoraemonMorph videoServer: videoServer) openInHand.
^videoServer! !

!RSDoraemonVideoServer class methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:33'!
lastFieldBounds
^LastFieldBounds ifNil: [(6.81@77.23) corner: (93.42@6.37)]! !

!RSDoraemonVideoServer class methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:34'!
lastGoalBounds
^LastGoalBounds ifNil: [(2.87@49.68) corner: (97.36@33.93)]! !

!RSDoraemonVideoServer class methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:32'!
lastPort
	^ LastPort
		ifNil: [6364]! !

!RSDoraemonVideoServer methodsFor: 'connection' stamp: 'Richo 10/27/2009 14:08'!
connectOnPort: portNumber
LastPort := portNumber.
self disconnect.
socket := (Socket newUDP setPort: portNumber)! !

!RSDoraemonVideoServer methodsFor: 'connection' stamp: 'Richo 10/26/2009 16:09'!
disconnect
self isConnected ifTrue:[
	socket closeAndDestroy.
	socket := nil]! !

!RSDoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:36'!
fieldBounds: aRectangle
LastFieldBounds := aRectangle.
fieldBounds := aRectangle! !

!RSDoraemonVideoServer methodsFor: 'receiving' stamp: 'Richo 10/27/2009 14:15'!
getData
	| data |
	data := String new: 512.
	socket waitForData; receiveDataInto: data.
	^ data! !

!RSDoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:36'!
goalBounds: aRectangle
LastGoalBounds := aRectangle.
goalBounds := aRectangle! !

!RSDoraemonVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 17:33'!
ifYellowTeamInvertFieldOf: env
	isYellowTeam
		ifTrue: [self invertFieldOf: env]! !

!RSDoraemonVideoServer methodsFor: 'initialize-release' stamp: 'Richo 11/2/2009 16:41'!
initialize
super initialize.
predictor := RSBallPredictor new.! !

!RSDoraemonVideoServer methodsFor: 'connection' stamp: 'Richo 9/29/2009 17:21'!
isConnected
^socket notNil! !

!RSDoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 10/30/2009 17:03'!
isYellowTeam: aBoolean
isYellowTeam:=aBoolean! !

!RSDoraemonVideoServer methodsFor: 'printing' stamp: 'Richo 10/26/2009 17:34'!
printOn: aStream
super printOn: aStream.
self isConnected ifTrue: [aStream nextPutAll: '(' , socket port asString , ')']! !

!RSDoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 11/2/2009 15:06'!
setBallPropertiesOf: env from: aCollection 
	| founded position |
	founded := (aCollection at: 3)
			= 'Found'.
	env currentBall founded: founded.
	founded ifTrue: [
	position := (aCollection at: 4) asNumber @ (aCollection at: 5) asNumber]
ifFalse: [position := predictor ballPositionAt: 1 on: (env lastEnvironment ifNil: [env])].
	env currentBall position: position.! !

!RSDoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 11/2/2009 16:40'!
setRobotPropertiesOf: env from: aCollection 
	| name robotNumber robot founded |
	name := aCollection second.
	robotNumber := name asInteger + 1.
	founded := (aCollection at: 3)
				= 'Found'.
	(name startsWith: 'y')
		ifTrue: [robot := isYellowTeam
						ifTrue: [env homeAt: robotNumber]
						ifFalse: [env opponentAt: robotNumber]]
		ifFalse: [robot := isYellowTeam
						ifTrue: [env opponentAt: robotNumber]
						ifFalse: [env homeAt: robotNumber]].
	founded
		ifTrue: [robot position: (aCollection at: 4) asNumber @ (aCollection at: 5) asNumber.
	robot
		rotation: (RSAngle radians: (aCollection at: 7) asNumber)].
	robot founded: founded! !

!RSDoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 11/2/2009 14:57'!
storeDataOn: env 
	| data parser variable resultado first |
	self isConnected ifFalse: [^self].
	data := self getData.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space].
	env lastBall position: env currentBall position x @ env currentBall position y.
	3 to: resultado size do: [:i|
		first := (resultado at: i) at: 1.
		first = '1'
			ifTrue: [self setBallPropertiesOf: env from: (resultado at: i)]
			ifFalse: [self setRobotPropertiesOf: env from: (resultado at: i)].
		].
	env
		fieldBounds: (fieldBounds).
	env
		goalBounds: (goalBounds).
	self ifYellowTeamInvertFieldOf: env.! !

RSDoraemonVideoServer subclass: #RSFakeDoraemonVideoServer
	instanceVariableNames: 'rnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Doraemon'!

!RSFakeDoraemonVideoServer methodsFor: 'receiving' stamp: 'Richo 10/27/2009 14:23'!
getData
| data |
data := super getData.
^self inDoraemonFormat: data.! !

!RSFakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:15'!
inDoraemonFormat: aString 
	| data parser variable resultado newData |
	data := aString.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space]. 
	newData := WriteStream on: ''.
	self printDoraemonHeaderOn: newData.
	self printBallInfoFrom: resultado on: newData.
	self printRobotsInfoFrom: resultado on: newData.
	self printOpponentsInfoFrom: resultado on: newData.
	^ newData contents! !

!RSFakeDoraemonVideoServer methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 14:20'!
initialize
super initialize.
rnd := Random new! !

!RSFakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:14'!
printBallInfoFrom: resultado on: newData
	rnd next < self uncertainty
		ifTrue: [newData nextPutAll: '1 ball NoFnd 0.0 0.0 0 0 0 0';
				 nextPut: Character lf]
		ifFalse: [newData nextPutAll: '1 ball Found '
					, ((resultado at: 1)
							at: 1) , ' '
					, ((resultado at: 1)
							at: 2) , ' 0 0 0 0';
				 nextPut: Character lf].! !

!RSFakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:13'!
printDoraemonHeaderOn: newData
	newData nextPutAll: '0 0 0';
		 nextPut: Character lf;
		 nextPutAll: '0 0 0';
		 nextPut: Character lf.! !

!RSFakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 16:42'!
printOpponentsInfoFrom: resultado on: newData 
	1
		to: 5
		do: [:i | rnd next < self uncertainty
				ifTrue: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['b']
									ifFalse: ['y']) , (i - 1) asString , ' NoFnd 0.0 0.0 0 0 0 0';
						 nextPut: Character lf]
				ifFalse: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['b']
									ifFalse: ['y']) , (i - 1) asString , ' Found '
							, ((resultado at: i + 6)
									at: 1) , ' '
							, ((resultado at: i + 6)
									at: 2) , ' 0 ' , ((resultado at: i + 6)
								at: 4) asNumber degreesToRadians asString , ' 0 0';
						 nextPut: Character lf]]! !

!RSFakeDoraemonVideoServer methodsFor: 'formatting' stamp: 'Richo 11/2/2009 15:17'!
printRobotsInfoFrom: resultado on: newData 
	1
		to: 5
		do: [:i | rnd next < self uncertainty
				ifTrue: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['y']
									ifFalse: ['b']) , (i - 1) asString , ' NoFnd 0.0 0.0 0 0 0 0';
						 nextPut: Character lf] 
				ifFalse: [newData nextPutAll: '0 '
							, (isYellowTeam
									ifTrue: ['y']
									ifFalse: ['b']) , (i - 1) asString , ' Found '
							, ((resultado at: i + 1)
									at: 1) , ' '
							, ((resultado at: i + 1)
									at: 2) , ' 0 ' , ((resultado at: i + 1)
								at: 4) asNumber degreesToRadians asString , ' 0 0';
						 nextPut: Character lf]]! !

!RSFakeDoraemonVideoServer methodsFor: 'parsing' stamp: 'Richo 11/2/2009 16:41'!
storeDataOnViejo: env
| i |
super storeDataOn: env.
env lastEnvironment ifNil: [^self].
rnd next < self uncertainty
ifTrue: [env currentBall position: (RSBallPredictor new ballPositionAt: 1 on: env lastEnvironment); 
					founded: false].
i := 1.
env home do: [:robot|
	rnd next < self uncertainty
	ifTrue: [
		robot position: (env lastEnvironment homeAt: i) position.
		robot rotation: (env lastEnvironment homeAt: i) rotation.
		].
	i := i + 1.
	].
i := 1.
env opponent do: [:robot|
	rnd next < self uncertainty
	ifTrue: [
		robot position: (env lastEnvironment opponentAt: i) position.
		robot rotation: (env lastEnvironment opponentAt: i) rotation.
		].
	i := i + 1.
	]! !

!RSFakeDoraemonVideoServer methodsFor: 'accessing' stamp: 'Richo 11/2/2009 16:32'!
uncertainty
	^ 0.4! !

RSVideoServer subclass: #RSEmptyVideoServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Empty'!

!RSEmptyVideoServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:09'!
fieldBounds
^0@0 corner: 1@1! !

!RSEmptyVideoServer class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:09'!
fromUser
^self new! !

!RSEmptyVideoServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:10'!
disconnect
! !

!RSEmptyVideoServer methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 18:09'!
storeDataOn: anEnvironment
! !

RSVideoServer subclass: #RSSimulatedVideoServer
	instanceVariableNames: 'socket isYellowTeam'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Simulated'!

RSSimulatedVideoServer class
	instanceVariableNames: 'lastPort'!

RSSimulatedVideoServer class
	instanceVariableNames: 'lastPort'!

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:27'!
anyonesBall
	^ 0! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:27'!
blueBall
	^ 1! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 4/1/2009 14:20'!
fieldBounds
	^ ( 6.8118@ 77.2392) corner: ( 93.4259@ 6.373)
! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
freeBall
	^ 1! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
freeKick
	^ 4! !

!RSSimulatedVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/14/2008 10:22'!
fromUser
	| port |
	port := (FillInTheBlank request: 'Port:' initialAnswer: self lastPort asString) asInteger.

	^ self port: port! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 4/1/2009 14:21'!
goalBounds
^ 2.8748 @ 49.6801 corner:  97.3632@ 33.932
! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
goalKick
	^ 5! !

!RSSimulatedVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:47'!
lastPort
^lastPort ifNil: [6364]! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
penaltyKick
	^ 3! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:28'!
placeKick
	^ 2! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:29'!
playersPerSide
	^ 5! !

!RSSimulatedVideoServer class methodsFor: 'instance creation' stamp: 'Richo 7/9/2008 22:48'!
port: aSmallInteger 
lastPort := aSmallInteger.
	^ self basicNew
		setSocket: (Socket newUDP setPort: aSmallInteger)! !

!RSSimulatedVideoServer class methodsFor: 'constants' stamp: 'Richo 6/21/2008 19:29'!
yellowBall
	^ 2! !

!RSSimulatedVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 16:44'!
decideTeamOf: env
	| rightSide leftSide |
	isYellowTeam
		ifNotNil: [^ self].
	rightSide := 0.
	leftSide := 0.
	env home
		do: [:each | each position x > env fieldBounds center x
				ifTrue: [rightSide := rightSide + 1]
				ifFalse: [leftSide := leftSide + 1]].
	env opponent
		do: [:each | each position x > env fieldBounds center x
				ifTrue: [rightSide := rightSide - 1]
				ifFalse: [leftSide := leftSide - 1]].
	isYellowTeam := leftSide > rightSide.
! !

!RSSimulatedVideoServer methodsFor: 'initialize-release' stamp: 'Richo 6/21/2008 18:58'!
disconnect
	socket closeAndDestroy! !

!RSSimulatedVideoServer methodsFor: 'receiving' stamp: 'Richo 6/21/2008 18:43'!
getData
	| data |
	data := String new: 512.
	socket waitForData; receiveDataInto: data.
	^data! !

!RSSimulatedVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 16:43'!
ifYellowTeamInvertFieldOf: env
	self decideTeamOf: env.
	isYellowTeam
		ifTrue: [self invertFieldOf: env]! !

!RSSimulatedVideoServer methodsFor: 'printing' stamp: 'Richo 7/12/2008 23:31'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , socket port asString , ')'! !

!RSSimulatedVideoServer methodsFor: 'private' stamp: 'Richo 6/21/2008 19:06'!
setSocket: aSocket 
socket := aSocket! !

!RSSimulatedVideoServer methodsFor: 'parsing' stamp: 'Richo 11/2/2009 15:09'!
storeDataOn: env 
	| data parser variable resultado i translateFactor |
	data := self getData.
	parser := TextDiffBuilder new.
	variable := parser split: data by: Character lf.
	resultado := variable
				collect: [:each | parser split: each by: Character space].
	env lastBall position: env currentBall position x @ env currentBall position y.
	env currentBall position: ((resultado at: 1)
			at: 1) asNumber @ ((resultado at: 1)
				at: 2) asNumber.
	env currentBall founded: true.
	i := 1.
	env home
		do: [:robot | 
			robot position: ((resultado at: i + 1)
					at: 1) asNumber @ ((resultado at: i + 1)
						at: 2) asNumber.
			robot
				rotation: (RSAngle degrees: ((resultado at: i + 1)
							at: 4) asNumber).
			robot founded: true.
			i := i + 1].
	i := 1.
	env opponent
		do: [:opponent | 
			opponent position: ((resultado at: i + 6)
					at: 1) asNumber @ ((resultado at: i + 6)
						at: 2) asNumber.
			opponent
				rotation: (RSAngle degrees: ((resultado at: i + 6)
							at: 4) asNumber).
			opponent founded: true.
			i := i + 1].
	env gameState: ((resultado at: 12)
			at: 1) asNumber.
	env whosBall: ((resultado at: 12)
			at: 2) asNumber.
	"The #translateBy: message fixes an error in the drawing. I hope this
	doesn't cause any trouble"
	translateFactor := isYellowTeam isNil
				ifTrue: [0 @ 0]
				ifFalse: [isYellowTeam
						ifTrue: [0 @ -1]
						ifFalse: [0 @ 1]].
	env
		fieldBounds: (self class fieldBounds translateBy: translateFactor).
	env goalBounds: self class goalBounds.
	self ifYellowTeamInvertFieldOf: env! !

!RSVideoServer class methodsFor: 'instance creation' stamp: 'Richo 6/22/2008 17:42'!
fromUser
"Devuelve la conexin al servidor de video"
	^ self subclassResponsibility! !

!RSVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 17:32'!
invertFieldOf: env
	self invertPositionOf: env currentBall in: env.
	self invertPositionOf: env lastBall in: env.
	env home
		do: [:r | 
			self invertPositionOf: r in: env.
			self invertRotationOf: r].
	env opponent
		do: [:r | 
			self invertPositionOf: r in: env.
			self invertRotationOf: r]! !

!RSVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 17:32'!
invertPositionOf: aRobotOrBall in: env

	aRobotOrBall position: env fieldBounds left + (env fieldBounds right - aRobotOrBall position x) @ (env fieldBounds bottom + (env fieldBounds top - aRobotOrBall position y))! !

!RSVideoServer methodsFor: 'inverting field' stamp: 'Richo 10/30/2009 17:32'!
invertRotationOf: aRobot
	"Suma 180 pero lo mantiene entre -180 y 180"
	aRobot rotation: aRobot rotation opposite! !

!RSVideoServer methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 17:53'!
storeDataOn: anEnvironment 
	"Recibe los datos, los parsea y los carga en el environment
	Datos que debera cargar en el environment:
	- home (Coleccin de RSRobot - Posicin y rotacin de cada robot
	propio). 
	- opponent (Coleccin de RSOpponentRobot - Posicin y rotacin
	de cada robot contrario).
	- currentBall (RSBall - Posicin de la pelota en este momento).
	- lastBall (RSBall - ltima posicin de la pelota).
	- fieldBounds (Rectangle - Lmites de la cancha).
	- goalBounts (Rectangle - Lmites de los arcos).
	- gameState (?).
	- whosBall (?).
	"
	self subclassResponsibility! !

Object subclass: #RSViewerPlugin
	instanceVariableNames: 'viewer isActive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

RSViewerPlugin subclass: #RSAdvancedDebuggerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSAdvancedDebuggerPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 16:37'!
priority
^RSReplayPlugin priority - 0.05! !

!RSAdvancedDebuggerPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/23/2009 16:31'!
debug
""
viewer currentEnv isNil ifTrue: [^self].
self halt.
viewer game team strategyFor: viewer currentEnv copy.
! !

!RSAdvancedDebuggerPlugin methodsFor: 'accessing' stamp: 'Richo 10/23/2009 16:36'!
menu
^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		" addMorphBack: 'Advanced debugger: ' asString asMorph;"
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: (SimpleButtonMorph new label: ' Debug strategy for current environment ... ';
				color: (Color red mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				cornerStyle: #rounded;
				 borderWidth: 2;
				 actionSelector: #debug;
				target: self);
				
			 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

RSViewerPlugin subclass: #RSBallPredictorPlugin
	instanceVariableNames: 'ballPredictions predictor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSBallPredictorPlugin methodsFor: 'initializing' stamp: 'Richo 11/2/2009 16:41'!
initialize
super initialize.
predictor := RSBallPredictor new.! !

!RSBallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
initializeBallPredictions
	| cant alpha |
	cant := 10.
	alpha := 1.
	ballPredictions := Array new: cant.
	1
		to: cant
		do: [:i | 
			ballPredictions
				at: i
				put: ((RSBallMorph new)
						color: (Color yellow alpha: alpha)).
			alpha := alpha - (alpha / (cant ))].
	ballPredictions
		do: [:each | viewer board addMorphBack: each]! !

!RSBallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
menu
	| menu actButton |
	menu := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: self class asString asMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer.
	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']]).
	^ menu! !

!RSBallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
removeBallPredictions
	ballPredictions
		do: [:each | each delete]! !

!RSBallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/25/2010 12:46'!
step
	| currentEnv |
	currentEnv := viewer currentEnv lastEnvironment ifNil: [viewer currentEnv ].
	ballPredictions
		doWithIndex: [:ball :index | 
			Transcript show: (predictor ballPositionAt: index on: currentEnv) asString; cr.
			viewer board setPosition: (predictor ballPositionAt: index on: currentEnv) of: ball in: currentEnv.]
! !

!RSBallPredictorPlugin methodsFor: 'as yet unclassified' stamp: 'Richo 10/27/2009 14:46'!
toggleActivateDeactivate
	super toggleActivateDeactivate.
	isActive
		ifTrue: [self initializeBallPredictions]
		ifFalse: [self removeBallPredictions]! !

RSViewerPlugin subclass: #RSFoundedPlugin
	instanceVariableNames: 'ball'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSFoundedPlugin methodsFor: 'accessing' stamp: 'Richo 11/2/2009 14:43'!
menu
	| menu actButton |
	menu :=  AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: self class asString asMorph;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer.

	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']]).
	^ menu! !

!RSFoundedPlugin methodsFor: 'stepping' stamp: 'Richo 11/2/2009 15:35'!
step
	| env homeMorphs morph opponentMorphs |
	env := viewer currentEnv.
	env currentBall founded
		ifTrue: [viewer board ball borderColor: Color green]
		ifFalse: [viewer board ball borderColor: Color red].
	homeMorphs := viewer board homeFor: env.
	1 to: homeMorphs size do: [:i|
		morph := homeMorphs at: i.
		(env homeAt: i) founded ifTrue: [morph borderColor: Color green] ifFalse: [morph borderColor: Color red]
		].
	opponentMorphs := viewer board opponentFor: env.
	1 to: opponentMorphs size do: [:i|
		morph := opponentMorphs at: i.
		(env opponentAt: i) founded ifTrue: [morph borderColor: Color green] ifFalse: [morph borderColor: Color red]
		].
	! !

!RSFoundedPlugin methodsFor: 'activation' stamp: 'Richo 11/2/2009 15:36'!
toggleActivateDeactivate
	super toggleActivateDeactivate.
	isActive
		ifTrue: [
			(viewer board homeFor: viewer currentEnv) do: [:morph| morph borderWidth: 1] .
			(viewer board opponentFor: viewer currentEnv) do: [:morph| morph borderWidth: 1] .
			]
		ifFalse: [
			(viewer board homeFor: viewer currentEnv) do: [:morph| morph borderWidth: 0] .
			(viewer board opponentFor: viewer currentEnv) do: [:morph| morph borderWidth: 0] .
			viewer board ball borderColor: Color black]! !

RSViewerPlugin subclass: #RSGCNowPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSGCNowPlugin methodsFor: 'accessing' stamp: 'Richo 11/2/2009 15:41'!
menu
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (SimpleButtonMorph new label: ' Smalltalk garbageCollect ';
			
			color: (Color yellow mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 cornerStyle: #rounded;
			 borderWidth: 2;
			 actionSelector: #garbageCollect;
			 target: Smalltalk);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer"addMorphBack: 'Advanced debugger: ' asString asMorph;"! !

RSViewerPlugin subclass: #RSImagesHolderPlugin
	instanceVariableNames: 'blueImageList yellowImageList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSImagesHolderPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2009 14:27'!
priority
^0.6! !

!RSImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:40'!
blueImageList

^blueImageList ifNil: [blueImageList := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 hResizing: #shrinkWrap;
		 wrapCentering: #center.]
	! !

!RSImagesHolderPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 15:36'!
initialize
super initialize.
1 to: 5 do: [:i|
	self blueImageList addMorphBack: (SketchMorph withForm: (viewer imagesHolder blueImageAt: i)).
	self yellowImageList addMorphBack: (SketchMorph withForm: (viewer imagesHolder yellowImageAt: i))
	]! !

!RSImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:41'!
menu
	| actButton menu |
menu := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center; 
"		addMorphBack: 'Robot''s images: ' asMorph;"
		addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: self yellowImageList;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		addMorphBack: self blueImageList;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer.
"	actButton := SimpleButtonMorph new label: ' Activate ';
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised;
				 borderWidth: 2.
	menu addMorphBack: (actButton actionSelector: #value;
			
			target: [self toggleActivateDeactivate.
				isActive
					ifTrue: [actButton color: (Color red mixed: 0.3 with: Color blue muchLighter);
							 label: ' Deactivate ']
					ifFalse: [actButton color: (Color green mixed: 0.3 with: Color blue muchLighter);
							 label: ' Activate ']])."
	^ menu
! !

!RSImagesHolderPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 15:34'!
step
! !

!RSImagesHolderPlugin methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:40'!
yellowImageList

^yellowImageList ifNil: [yellowImageList := AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 hResizing: #shrinkWrap;
		 wrapCentering: #center.]
	! !

RSViewerPlugin subclass: #RSReplayPlugin
	instanceVariableNames: 'currentEnvIndex isPlaying playButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer-Plugins'!

!RSReplayPlugin class methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2009 14:27'!
priority
^0.6! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:35'!
activate 
isActive ifTrue: [^self].
isActive := true.
currentEnvIndex := 0.
viewer controlPanel pause.! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/21/2009 14:01'!
deactivate 
isActive := false.! !

!RSReplayPlugin methodsFor: 'stepping' stamp: 'Richo 10/27/2009 17:33'!
decreaseIndex
	currentEnvIndex := currentEnvIndex - 1.
	currentEnvIndex < 0
		ifTrue: [currentEnvIndex := 0. isPlaying := false]! !

!RSReplayPlugin methodsFor: 'accessing' stamp: 'Richo 10/27/2009 17:33'!
environmentsCount
| last count |
last := viewer game environment.
count := 0.
[last lastEnvironment isNil]
whileFalse: [last := last lastEnvironment. 
	count := count + 1].
^count! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:31'!
goToFirst
self activate.
currentEnvIndex := self environmentsCount! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:29'!
goToLast
self activate.
currentEnvIndex := 0! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 17:36'!
goToNext
self activate.
currentEnvIndex := currentEnvIndex - 1 max: 0! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/27/2009 18:09'!
goToPrevious
self activate.
currentEnvIndex := currentEnvIndex + 1 min: self environmentsCount! !

!RSReplayPlugin methodsFor: 'initializing' stamp: 'Richo 10/21/2009 14:21'!
initialize
super initialize.
currentEnvIndex := 1.
isPlaying := false.! !

!RSReplayPlugin methodsFor: 'accessing' stamp: 'Richo 10/26/2009 14:34'!
menu
	| menu |
	menu := AlignmentMorph newRow color: Color transparent;
				 cornerStyle: #rounded;
				 borderWidth: 0;
				 layoutInset: 3;
				 vResizing: #shrinkWrap;
				 wrapCentering: #center;
				addMorphBack: AlignmentMorph newVariableTransparentSpacer ;

				 addMorphBack: (SimpleButtonMorph new label: ' << First ';
					
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToFirst; 
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' < Previous ';
										
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToPrevious;
					 actWhen: #whilePressed;
					 target: self).
		playButton := (SimpleButtonMorph new label: ' - Play from here - ';
						
					color:  (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2).
				menu addMorphBack: (playButton
					 actionSelector: #play;
					 actWhen: #buttonUp;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' Next > ';
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToNext;
					 actWhen: #whilePressed;
					 target: self);
				 addMorphBack: (SimpleButtonMorph new label: ' Last >> ';
						
					color:   (Color blue  mixed: 0.2 with: Color orange muchLighter);
					 borderColor: #raised;
					cornerStyle: #rounded;
					 borderWidth: 2;
					 actionSelector: #goToLast;
					 target: self);
									addMorphBack: AlignmentMorph newVariableTransparentSpacer .
									^menu! !

!RSReplayPlugin methodsFor: 'actions' stamp: 'Richo 10/23/2009 16:33'!
play
isPlaying := isPlaying not! !

!RSReplayPlugin methodsFor: 'stepping' stamp: 'Richo 10/27/2009 18:10'!
step
viewer gameState = #run ifTrue: [^self deactivate].
viewer currentEnv: (viewer game environment lastEnvironment: currentEnvIndex).
isPlaying ifTrue: [self decreaseIndex.
						playButton label: ' - Stop - '; borderColor: (Color red mixed: 0.7 with: Color orange )]
						ifFalse: [playButton label: ' - Play from here - '; borderColor: #raised]
						! !

!RSViewerPlugin class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 12:05'!
on: aRSViewerMorph
^(self basicNew setViewer: aRSViewerMorph ) initialize! !

!RSViewerPlugin class methodsFor: 'constants' stamp: 'Richo 10/18/2009 17:24'!
priority
"Subclasses should change this value if they need to execute themselves in a specific order. Higher number means higher priority.

Range 0.0 ... 1.0"
^0.5! !

!RSViewerPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 12:06'!
initialize
isActive := false! !

!RSViewerPlugin methodsFor: 'initializing' stamp: 'Richo 10/13/2009 12:07'!
menu
	"Debe devolver un menu para activar/desactivar el plugin"
	self subclassResponsibility! !

!RSViewerPlugin methodsFor: 'private' stamp: 'Richo 10/13/2009 12:06'!
setViewer: aRSViewerMorph
	viewer := aRSViewerMorph ! !

!RSViewerPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 12:06'!
step
self subclassResponsibility! !

!RSViewerPlugin methodsFor: 'stepping' stamp: 'Richo 10/13/2009 12:06'!
stepIfActive
	isActive ifTrue: [self step]! !

!RSViewerPlugin methodsFor: 'activation' stamp: 'Richo 10/20/2009 12:42'!
toggleActivateDeactivate
	isActive := isActive not.! !

Morph subclass: #RSBoardMorph
	instanceVariableNames: 'ball home opponent imagesHolder gameState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

RSBoardMorph class
	instanceVariableNames: 'form'!

RSBoardMorph class
	instanceVariableNames: 'form'!

!RSBoardMorph class methodsFor: 'form' stamp: 'Richo 10/9/2009 15:57'!
form
	^ form
		ifNil: [self initializeForm]! !

!RSBoardMorph class methodsFor: 'form' stamp: 'Richo 10/9/2009 15:58'!
initializeForm
^form := (Form
	extent: 675@500
	depth: 1
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294966784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194303 4294967295 4294967295 3758096384 4294967295 4294967295 4294966272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1048575 4294967295 4294967295 3758096384 4294967295 4294967295 4294965375 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278714367 4294967295 4294967295 3758096384 4294967295 4294967295 4294963455 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286840831 4294967295 4294967295 3758096384 4294967295 4294967295 4294959615 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4290904063 4294967295 4294967295 3758096384 4294967295 4294967295 4294951935 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4292935679 4294967295 4294967295 3758096384 4294967295 4294967295 4294936575 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293951487 4294967295 4294967295 3758096384 4294967295 4294967295 4294905855 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294459391 4294967295 4294967295 3758096384 4294967295 4294967295 4294844415 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294713343 4294967295 4294967295 3758096384 4294967295 4294967295 4294721535 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294840319 4294967295 4294967295 3758096384 4294967295 4294967295 4294475775 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294903807 4294967295 4294967295 3758096384 4294967295 4294967295 4293984255 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294935551 4294967295 4294967295 3758096384 4294967295 4294967295 4293001215 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294951423 4294967295 4294967295 3758096384 4294967295 4294967295 4291035135 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294959359 4294967295 4294967295 3758096384 4294967295 4294967295 4287102975 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294963327 4294967295 4294967295 3758096384 4294967295 4294967295 4279238655 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965311 4294967295 4294967295 3758096384 4294967295 4294967295 4263510015 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966303 4294967295 4294967295 3758096384 4294967295 4294967295 4232052735 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966799 4294967295 4294967295 3758096384 4294967295 4294967295 4169138175 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967047 4294967295 4294967295 3758096384 4294967295 4294967295 4043309055 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967171 4294967295 4294967295 3758096384 4294967295 4294967295 3791650815 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967233 4294967295 4294967295 3758096384 4294967295 4294967295 3288334335 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967264 4294967295 4294967295 3758096384 4294967295 4294967295 2281701375 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967280 2147483647 4294967295 3758096384 4294967295 4294967295 268435455 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967288 1073741823 4294967295 3758096384 4294967295 4294967294 536870911 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967292 536870911 4294967295 3758096384 4294967295 4294967292 1073741823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967294 268435455 4294967295 3758096384 4294967295 4294967288 2147483647 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 134217727 4294967295 3758096384 4294967295 4294967288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 2281701375 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4278190207 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 3221225473 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967292 16727936 536870911 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967264 1073692670 67108863 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967043 4294918143 3766484991 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294966303 4294918143 4229955583 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294963327 4294918143 4278714367 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294951935 4294918143 4293001215 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294905855 4294918143 4294475775 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294852607 4294918143 4294852607 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294475775 4294918143 4294905855 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294049791 4294918143 4294952959 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4291035135 4294918143 4294959615 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4287627263 4294918143 4294965503 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4280287231 4294918143 4294966399 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4232052735 4294918143 4294966815 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4177526783 4294918143 4294967183 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4060086271 4294918143 4294967239 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3825205247 4294918143 4294967267 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3355443199 4294918143 4294967281 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2415919103 4294918143 4294967288 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2684354559 4294918143 4294967292 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 1073741823 4294918143 4294967294 2147483647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967294 1073741823 4294918143 4294967294 1073741823 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 2147483647 4294918143 4294967295 536870911 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 4294967295 4294918143 4294967295 2684354559 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967289 4294967295 4294918143 4294967295 3489660927 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967281 4294967295 4294918143 4294967295 3355443199 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967283 4294967295 4294918143 4294967295 3892314111 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967271 4294967295 4294918143 4294967295 4093640703 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967239 4294967295 4294918143 4294967295 4060086271 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967247 4294967295 4294918143 4294967295 4194303999 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966399 4294967295 4294918143 4294967295 4280287231 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964103 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4041736191 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963971 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3764912127 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963833 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3475505151 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294963971 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 3764912127 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964103 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4041736191 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294955007 4294967295 4294918143 4294967295 4294574079 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294705151 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294705151 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294961151 4294967295 4294918143 4294967295 4294180863 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294964223 4294967295 4294918143 4294967295 4293394431 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294965759 4294967295 4294918143 4294967295 4291821567 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966527 4294967295 4294918143 4294967295 4288675839 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966399 4294967295 4294918143 4294967295 4280287231 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294966911 4294967295 4294918143 4294967295 4282384383 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967103 4294967295 4294918143 4294967295 4269801471 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967199 4294967295 4294918143 4294967295 4244635647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967247 4294967295 4294918143 4294967295 4194303999 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967239 4294967295 4294918143 4294967295 4060086271 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967271 4294967295 4294918143 4294967295 4093640703 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967283 4294967295 4294918143 4294967295 3892314111 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967281 4294967295 4294918143 4294967295 3355443199 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967289 4294967295 4294918143 4294967295 3489660927 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 4294967295 4294918143 4294967295 2684354559 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967292 2147483647 4294918143 4294967295 536870911 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967294 1073741823 4294918143 4294967294 1073741823 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 1073741823 4294918143 4294967294 2147483647 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2684354559 4294918143 4294967292 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 2415919103 4294918143 4294967288 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3355443199 4294918143 4294967281 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 3825205247 4294918143 4294967267 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4060086271 4294918143 4294967239 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4177526783 4294918143 4294967183 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4232052735 4294918143 4294966815 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4280287231 4294918143 4294966399 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966911 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4287627263 4294918143 4294965503 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4282384383 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4291035135 4294918143 4294959615 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294966784 1 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294049791 4294918143 4294952959 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3758096384 4194303 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294475775 4294918143 4294905855 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294852607 4294918143 4294852607 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294905855 4294918143 4294475775 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294951935 4294918143 4293001215 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294963327 4294918143 4278714367 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294966303 4294918143 4229955583 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967043 4294918143 3766484991 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967264 1073692670 67108863 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967292 16727936 536870911 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 3489660927 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 3221225473 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967289 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4278190207 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967288 0 268435455 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967288 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294964223 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4293394431 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967288 0 0 1023 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4292870144 0 0 134217727 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 3886022655 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966515 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4030726143 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294966791 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4169138175 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967055 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4282384383 4294967295 4294967295 4294967295 4194303999 4294967295 4294918143 4294967295 4294967271 4294967295 4294967295 4294967295 4294967103 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3892314111 4294967295 3758096384 4294967295 4294967289 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3355443199 4294967295 3758096384 4294967295 4294967288 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 2281701375 4294967295 3758096384 4294967295 4294967292 2147483647 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 268435455 4294967295 3758096384 4294967295 4294967294 1073741823 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967294 536870911 4294967295 3758096384 4294967295 4294967295 536870911 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967292 1073741823 4294967295 3758096384 4294967295 4294967295 2415919103 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967288 2147483647 4294967295 3758096384 4294967295 4294967295 3355443199 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967280 4294967295 4294967295 3758096384 4294967295 4294967295 3825205247 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967265 4294967295 4294967295 3758096384 4294967295 4294967295 4060086271 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967235 4294967295 4294967295 3758096384 4294967295 4294967295 4177526783 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967175 4294967295 4294967295 3758096384 4294967295 4294967295 4236247039 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967055 4294967295 4294967295 3758096384 4294967295 4294967295 4265607167 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966815 4294967295 4294967295 3758096384 4294967295 4294967295 4280287231 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294966335 4294967295 4294967295 3758096384 4294967295 4294967295 4287627263 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294965375 4294967295 4294967295 3758096384 4294967295 4294967295 4291297279 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294963455 4294967295 4294967295 3758096384 4294967295 4294967295 4293132287 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294959615 4294967295 4294967295 3758096384 4294967295 4294967295 4294049791 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294951935 4294967295 4294967295 3758096384 4294967295 4294967295 4294508543 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294936575 4294967295 4294967295 3758096384 4294967295 4294967295 4294737919 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294905855 4294967295 4294967295 3758096384 4294967295 4294967295 4294852607 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294844415 4294967295 4294967295 3758096384 4294967295 4294967295 4294909951 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294721535 4294967295 4294967295 3758096384 4294967295 4294967295 4294938623 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294475775 4294967295 4294967295 3758096384 4294967295 4294967295 4294952959 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293984255 4294967295 4294967295 3758096384 4294967295 4294967295 4294960127 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293001215 4294967295 4294967295 3758096384 4294967295 4294967295 4294963711 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4291035135 4294967295 4294967295 3758096384 4294967295 4294967295 4294965503 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4287102975 4294967295 4294967295 3758096384 4294967295 4294967295 4294966399 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4279238655 4294967295 4294967295 3758096384 4294967295 4294967295 4294966847 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294918143 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4263510015 4294967295 4294967295 3758096384 4294967295 4294967295 4294966784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194303 4294967295 4294967295 3758096384 4294967295 4294967295 4294967040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8388607 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 3758096384)
	offset: 0@0)! !

!RSBoardMorph class methodsFor: 'conversion' stamp: 'Richo 10/9/2009 17:35'!
squeakAngle: robotSoccerAngle 
| angN dif |
angN := 90 - robotSoccerAngle.
angN>180 ifTrue:[
	dif := angN - 180.
	angN := -180 + dif.
	
	].
^angN! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 14:17'!
ball
	ball
		isNil ifTrue: [self addMorph: (ball := RSBallMorph new)].
	^ ball! !

!RSBoardMorph methodsFor: 'drawing environment' stamp: 'Richo 10/22/2010 18:18'!
draw: env 
"I draw the environment and refresh the event handling to inspect the current objects"
	| i r |
	self
		setPosition: env currentBall position 
		of: (self ball
				on: #mouseDown
				send: #inspect
				to: env currentBall)
		in: env.
	i := 1.
	(self homeFor: env)
		do: [:each | 
			r := env homeAt: i.
			self
				setPosition: r position 
				of: each
				in: env.
			each
				heading: (self class squeakAngle: r rotation degrees);
				
				on: #mouseDown
				send: #inspect
				to: r.
			i := i + 1].
	i := 1.
	(self opponentFor: env)
		do: [:each | 
			r := env opponentAt: i.
			self
				setPosition: r position 
				of: each
				in: env.
			each
				heading: (self class squeakAngle: r rotation degrees);
				
				on: #mouseDown
				send: #inspect
				to: r.
			i := i + 1]! !

!RSBoardMorph methodsFor: 'drawing' stamp: 'Richo 10/9/2009 16:00'!
drawOn: aCanvas
	aCanvas drawImage: self class form at: self topLeft! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/9/2009 16:53'!
fieldBounds
^self bounds topLeft + (61@24) corner: (self bounds topLeft + (612@475))! !

!RSBoardMorph methodsFor: 'game state' stamp: 'Richo 10/23/2009 18:08'!
gameState: aSymbol
"aSymbol may be one of the following:
#stop
#pause
#run"
| newContents newColor |
newContents := ''.
newColor := Color transparent.
aSymbol = #stop ifTrue: [newContents := 'Stopped'. newColor := Color red].
aSymbol = #pause ifTrue: [newContents := 'Paused'. newColor := Color yellow].
aSymbol = #run ifTrue: [newContents := 'Running...'. newColor := Color green].
gameState contents = newContents ifFalse: [gameState contents: newContents].
gameState color = newColor ifFalse: [gameState color: newColor].! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 11/2/2009 16:05'!
homeFor: env 
	"Arreglar eso para luego poder elegir las imgenes de cada robot"

	home isNil
		ifTrue: [home := (1 to: env home size)
								collect: [:i | RSRobotMorph
										withForm: (imagesHolder blueImageAt: i)].
			home
				do: [:r | self addMorph: r]]
			ifFalse: [
				env home size = home size
				ifFalse: [home do: [:m | m delete]. 
					home := nil.
					^self homeFor: env].
				]
			.
	^ home! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:23'!
imagesHolder
^imagesHolder! !

!RSBoardMorph methodsFor: 'initialize' stamp: 'Richo 10/21/2009 13:35'!
initialize
	super initialize.
	self
		extent: (self class form extent);
		 cornerStyle: #rounded.
	imagesHolder := RSImagesHolder new.
	gameState := '' asString asMorph font: Preferences windowTitleFont;
		 color: Color red.
	self addMorph: (gameState topLeft: self topLeft + (5@2)).! !

!RSBoardMorph methodsFor: 'accessing' stamp: 'Richo 11/2/2009 16:06'!
opponentFor: env 
	"Arreglar eso para luego poder elegir las imgenes de cada robot"
	opponent isNil
		ifTrue: [opponent := (1 to: env opponent size)
								collect: [:i | RSRobotMorph
										withForm: (imagesHolder yellowImageAt: i)].
			opponent
				do: [:r | self addMorph: r]]
			ifFalse: [env opponent size = opponent size
				ifFalse: [opponent
						do: [:m | m delete].
					opponent := nil.
					^ self opponentFor: env]].
	^ opponent! !

!RSBoardMorph methodsFor: 'drawing environment' stamp: 'Richo 10/22/2010 18:31'!
setPosition: aPoint of: aMorph in: anEnvironment 
	| differenceWithCenter pixelDifference newCenter |
	differenceWithCenter := aPoint - anEnvironment fieldBounds center.
	differenceWithCenter := differenceWithCenter x @ (differenceWithCenter y * -1).
	pixelDifference := differenceWithCenter * self fieldBounds width / anEnvironment fieldBounds width.
	newCenter :=  self fieldBounds center + pixelDifference.
	(self bounds containsPoint: newCenter)
		ifTrue: [	aMorph center: newCenter]
		ifFalse: [aMorph center: (self bounds pointNearestTo: newCenter)]! !

Morph subclass: #RSRobotMorph
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSRobotMorph class methodsFor: 'instance creation' stamp: 'Richo 10/9/2009 18:00'!
new
self shouldNotImplement.
! !

!RSRobotMorph class methodsFor: 'instance creation' stamp: 'Richo 10/13/2009 10:35'!
withForm: aForm
^(self basicNew setForm: aForm) initialize! !

!RSRobotMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:33'!
center
(self owner isMemberOf: TransformationMorph)
ifTrue:[^self owner center].
^super center
! !

!RSRobotMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:33'!
center: aPoint 
"Para mantener las coordenadas correctas si el robot gira"
	(self owner isMemberOf: TransformationMorph)
		ifTrue: [^ self owner center: aPoint].
	^ super center: aPoint! !

!RSRobotMorph methodsFor: 'drawing' stamp: 'Richo 11/2/2009 15:30'!
drawOn: aCanvas
aCanvas translucentImage: form at: self bounds topLeft.
aCanvas frameRectangle: self bounds width: self borderWidth color: self borderColor! !

!RSRobotMorph methodsFor: 'initialize' stamp: 'Richo 11/2/2009 15:30'!
initialize
super initialize.
self extent: form extent! !

!RSRobotMorph methodsFor: 'private' stamp: 'Richo 10/13/2009 10:34'!
setForm: aForm
form := aForm! !

AlignmentMorph subclass: #RSControlPanelMorph
	instanceVariableNames: 'game robotServerLabel videoServerLabel teamLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSControlPanelMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/26/2009 17:43'!
on: aGame
^(self basicNew setGame: aGame) initialize! !

!RSControlPanelMorph methodsFor: 'robot server' stamp: 'Richo 10/26/2009 17:19'!
chooseRobotServerClass
	| choice robotServers strRobotServers |
	robotServers := RSRobotServer allSubclasses asArray sort: [:a :b | a name < b name].
	strRobotServers := robotServers
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'RobotServers:' chooseFrom: strRobotServers.
	choice = 0
		ifTrue: [^ nil].
	^robotServers at: choice! !

!RSControlPanelMorph methodsFor: 'team' stamp: 'Richo 10/26/2009 17:18'!
chooseTeamClass
	| teams strTeams choice |
		
	teams := RSTeam allSubclasses asArray sort: [:a :b | a name < b name].
	strTeams := teams
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'Teams:' chooseFrom: strTeams.
	choice = 0
		ifTrue: [^ nil].
	^ teams at: choice! !

!RSControlPanelMorph methodsFor: 'video server' stamp: 'Richo 10/26/2009 17:19'!
chooseVideoServerClass
	| choice videoServers strVideoServers |
	videoServers := RSVideoServer allSubclasses asArray sort: [:a :b | a name < b name].
	strVideoServers := videoServers
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'VideoServers:' chooseFrom: strVideoServers.
	choice = 0
		ifTrue: [^ nil].
	^videoServers at: choice! !

!RSControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 16:59'!
initialize
super initialize.
self listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		extent: 1@1;
		borderWidth: 0;
		color: Color transparent.
self initializeSubmorphs! !

!RSControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 17:06'!
initializeSubmorphs
self addMorphBack: self makeConnectionPanel;
		 addMorphBack: self makeControlPanel! !

!RSControlPanelMorph methodsFor: 'building' stamp: 'Richo 11/1/2009 21:18'!
makeConnectionPanel
	^ AlignmentMorph newColumn color: Color transparent;
		 addMorphBack: self makeTeamControlPanel;
		 addMorphBack: self makeVideoServerControlPanel;
		 addMorphBack: self makeRobotServerControlPanel
! !

!RSControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:59'!
makeControlPanel
	^ AlignmentMorph newColumn color: Color transparent;
		 addMorphBack: self makeStartPauseStopPanel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 23:53'!
makeRobotServerControlPanel
	robotServerLabel := game robotServer asString asMorph.
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  RobotServer ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #setRobotServer;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Remove  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #removeRobotServer;
			 target: self);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: robotServerLabel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 17:00'!
makeStartPauseStopPanel
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
				 addMorphBack: AlignmentMorph newVariableTransparentSpacer ;
		 addMorphBack: (SimpleButtonMorph new label: '  Start  ';
			
			color: (Color green mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #start;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Pause  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #pause;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Stop  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #stop;
			 target: self)! !

!RSControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 23:53'!
makeTeamControlPanel
	teamLabel := game team asString asMorph.
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  Team ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #setTeam;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Remove  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #removeTeam;
			 target: self);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: teamLabel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSControlPanelMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 23:53'!
makeVideoServerControlPanel
	videoServerLabel := game videoServer asString asMorph.
	^ AlignmentMorph newRow color: Color transparent;
		 addMorphBack: (SimpleButtonMorph new label: '  VideoServer ...  ';
			
			color: (Color blue mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #setVideoServer;
			 target: self);
		 addMorphBack: (SimpleButtonMorph new label: '  Remove  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #removeVideoServer;
			 target: self);
		 addMorphBack: ' --> ' asMorph;
		 addMorphBack: videoServerLabel;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer! !

!RSControlPanelMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/26/2009 17:44'!
pause
game pause.! !

!RSControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 23:50'!
removeAll
game removeAll.
self updateLabels! !

!RSControlPanelMorph methodsFor: 'robot server' stamp: 'Richo 10/26/2009 23:51'!
removeRobotServer
game removeRobotServer .
self updateLabels! !

!RSControlPanelMorph methodsFor: 'team' stamp: 'Richo 10/26/2009 23:51'!
removeTeam
game removeTeam.
self updateLabels! !

!RSControlPanelMorph methodsFor: 'video server' stamp: 'Richo 10/26/2009 23:51'!
removeVideoServer
game removeVideoServer .
self updateLabels! !

!RSControlPanelMorph methodsFor: 'private' stamp: 'Richo 10/26/2009 17:43'!
setGame: aGame
game := aGame! !

!RSControlPanelMorph methodsFor: 'robot server' stamp: 'Richo 10/26/2009 23:53'!
setRobotServer
	| robotServerClass |
	robotServerClass := self chooseRobotServerClass.
	robotServerClass
		ifNotNil: [game robotServer: robotServerClass fromUser].
	self updateLabels! !

!RSControlPanelMorph methodsFor: 'team' stamp: 'Richo 10/30/2009 17:57'!
setTeam
	| teamClass |
	teamClass := self chooseTeamClass.
	teamClass
		ifNotNil: [game team: teamClass fromUser].
	self updateLabels! !

!RSControlPanelMorph methodsFor: 'video server' stamp: 'Richo 10/26/2009 23:53'!
setVideoServer
	| videoServerClass |
	videoServerClass := self chooseVideoServerClass.
	videoServerClass
		ifNotNil: [game videoServer: videoServerClass fromUser].
	self updateLabels! !

!RSControlPanelMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/26/2009 17:44'!
start	
	[game start] on: Error do: [:err| ^self inform: err description].
! !

!RSControlPanelMorph methodsFor: 'stepping' stamp: 'Richo 10/26/2009 23:43'!
step
self updateLabels! !

!RSControlPanelMorph methodsFor: 'stepping' stamp: 'Richo 10/26/2009 23:43'!
stepTime
^1000! !

!RSControlPanelMorph methodsFor: 'start/pause/stop' stamp: 'Richo 10/30/2009 15:56'!
stop
	game stop.
	"self removeAll."
	"viewer
		submorphsDo: [:m | m delete].
	viewer initializeSubmorphs"! !

!RSControlPanelMorph methodsFor: 'updating' stamp: 'Richo 10/26/2009 23:44'!
updateLabels
	robotServerLabel contents = game robotServer asString
		ifFalse: [robotServerLabel contents: game robotServer asString]. 
	videoServerLabel contents = game videoServer asString
		ifFalse: [videoServerLabel contents: game videoServer asString].
	teamLabel contents = game team asString
		ifFalse: [teamLabel contents: game team asString]! !

AlignmentMorph subclass: #RSDoraemonMorph
	instanceVariableNames: 'videoServer portText fieldBoundsText goalBoundsText connectionButton isYellowTeam'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-Doraemon'!

RSDoraemonMorph class
	instanceVariableNames: 'videoServer'!

RSDoraemonMorph class
	instanceVariableNames: 'videoServer'!

!RSDoraemonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/27/2009 00:04'!
new
^self videoServer: RSDoraemonVideoServer new! !

!RSDoraemonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/27/2009 00:03'!
videoServer: aVideoServer
^(self basicNew setVideoServer: aVideoServer) initialize! !

!RSDoraemonMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 17:18'!
connect
videoServer fieldBounds: self fieldBounds; goalBounds: self goalBounds; isYellowTeam: isYellowTeam; connectOnPort: self port.! !

!RSDoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 23:45'!
delete
self disconnect.
super delete.! !

!RSDoraemonMorph methodsFor: 'connection' stamp: 'Richo 10/26/2009 23:45'!
disconnect
videoServer disconnect.
! !

!RSDoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:16'!
fieldBounds
^Compiler evaluate: fieldBoundsText contents asString! !

!RSDoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:16'!
goalBounds
^Compiler evaluate: goalBoundsText contents asString! !

!RSDoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 17:11'!
initialize
	super initialize.
	self borderWidth: 2;
		
		color: ((Color
				r: 0.817
				g: 0.864
				b: 0.797)
				mixed: 0.75
				with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	isYellowTeam := false.
	self initializeSubmorphs! !

!RSDoraemonMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 17:09'!
initializeSubmorphs
self addMorphBack: self makeTitle;
	addMorphBack: self makePortPanel;
	addMorphBack: self makeFieldBoundsPanel;
	addMorphBack: self makeGoalBoundsPanel;
	addMorphBack: self makeIsYellowTeamPanel;
	addMorphBack: self makeConnectionPanel.! !

!RSDoraemonMorph methodsFor: 'connection' stamp: 'Richo 10/26/2009 16:28'!
isConnected
^videoServer isConnected! !

!RSDoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 17:11'!
isYellowTeam
^isYellowTeam! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/27/2009 12:29'!
makeConnectionPanel
	connectionButton := SimpleButtonMorph new label: ' Connect ';
				
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (connectionButton actionSelector: #value;
			
			target: [self isConnected
					ifTrue: [self disconnect]
					ifFalse: [self connect].
					self updateConnectionButton.
					])! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:35'!
makeFieldBoundsPanel
fieldBoundsText := self newTextMorph contents: videoServer class lastFieldBounds storeString.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Field bounds: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (fieldBoundsText)! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:36'!
makeGoalBoundsPanel
goalBoundsText :=  self newTextMorph  contents: videoServer class lastGoalBounds storeString.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Goal bounds: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (goalBoundsText)! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:17'!
makeIsYellowTeamPanel
^Morph new extent: 0 @ 25;
				 cellInset: 10;
				 color: Color transparent;
				 layoutPolicy: TableLayout new;
				 listDirection: #leftToRight;
				listCentering: #center;
				 wrapCentering: #center;
				 hResizing: #spaceFill;
				 vResizing: #rigid;
				 addMorphBack: (UpdatingThreePhaseButtonMorph checkBox target: self;
					 actionSelector: #toggleIsYellowTeam;
					 getSelector: #isYellowTeam;
					 yourself);
				addMorphBack: 'is yellow team' asMorph! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:36'!
makePortPanel
portText := self newTextMorph contents: videoServer class lastPort asString.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Port: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (portText)! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:47'!
makeTitle
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: (self asString asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer";
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)"! !

!RSDoraemonMorph methodsFor: 'building' stamp: 'Richo 10/26/2009 16:02'!
newTextMorph
^TextMorph new autoFit: false;
extent: 250@23; borderWidth: 1;backgroundColor: Color white.! !

!RSDoraemonMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 16:15'!
port
^portText contents asString asNumber! !

!RSDoraemonMorph methodsFor: 'private' stamp: 'Richo 10/27/2009 00:03'!
setVideoServer: aVideoServer
videoServer := aVideoServer! !

!RSDoraemonMorph methodsFor: 'stepping' stamp: 'Richo 10/27/2009 12:28'!
step
self updateConnectionButton.! !

!RSDoraemonMorph methodsFor: 'stepping' stamp: 'Richo 10/27/2009 12:28'!
stepTime
^1000
! !

!RSDoraemonMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/30/2009 17:11'!
toggleIsYellowTeam
isYellowTeam := isYellowTeam not! !

!RSDoraemonMorph methodsFor: 'updating' stamp: 'Richo 10/27/2009 14:22'!
updateConnectionButton
self isConnected
					ifFalse: [
						connectionButton label: ' Connect ';
							
							color: (Color green mixed: 0.3 with: Color blue muchLighter)]
					ifTrue: [
						connectionButton label: ' Disconnect ';
							
							color: (Color red mixed: 0.3 with: Color blue muchLighter)]! !

!RSDoraemonMorph methodsFor: 'accessing' stamp: 'Richo 9/29/2009 17:20'!
videoServer
	^ videoServer! !

AlignmentMorph subclass: #RSLegoNxtMorph
	instanceVariableNames: 'robotServer numberOfRobots legoPortsTexts connectionButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Servers-Real-LegoNxt'!

!RSLegoNxtMorph class methodsFor: 'instance creation' stamp: 'Richo 10/28/2009 15:40'!
on: robotServer 
^(self basicNew setRobotServer: robotServer) initialize! !

!RSLegoNxtMorph methodsFor: 'actions' stamp: 'Richo 10/30/2009 15:08'!
changeNumberOfRobots
	| n |
	n := (FillInTheBlank request: 'Number of robots:' initialAnswer: numberOfRobots asString) asInteger.
	self numberOfRobots: n.
	self submorphsDo: [:m| m delete].
	self initializeSubmorphs.! !

!RSLegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:37'!
connectAll
1 to: numberOfRobots do: [:i| self connectAt: i]! !

!RSLegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:13'!
connectAt: nRobot
robotServer connectRobotAt: nRobot on: (self legoPorts at: nRobot)
! !

!RSLegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 15:15'!
delete
self disconnectAll.
super delete.! !

!RSLegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:37'!
disconnectAll
1 to: numberOfRobots do: [:i| self disconnectAt: i]! !

!RSLegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:15'!
disconnectAt: nRobot
robotServer disconnectAt: nRobot! !

!RSLegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 15:05'!
initialize
	super initialize.
	self borderWidth: 2;
		
		color: ((Color
				r: 0.817
				g: 0.864
				b: 0.797)
				mixed: 0.75
				with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	self numberOfRobots: 3.
	self initializeSubmorphs! !

!RSLegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 10/30/2009 15:32'!
initializeSubmorphs
self addMorphBack: self makeTitle;
	addMorphBack: self makeNRobotsPanel.
1 to: numberOfRobots do: [:i|
	self addMorphBack: (self makeLegoConnectionPanelFor: i)
	].
self addMorphBack: self makeAllConnectionPanel! !

!RSLegoNxtMorph methodsFor: 'connection' stamp: 'Richo 10/30/2009 15:15'!
isConnectedAt: nRobot
^robotServer isConnectedAt: nRobot! !

!RSLegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 15:14'!
legoPorts
^legoPortsTexts collect: [:each| each contents asNumber]! !

!RSLegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:52'!
makeAllConnectionPanel
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		addMorphBack: AlignmentMorph newVariableTransparentSpacer ;
		 addMorphBack: (SimpleButtonMorph new label: ' Connect all ';
				
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2;
				actionSelector: #value;
			
			target: [self connectAll.
					self updateConnectionButtons.
					]
				);
		addMorphBack: ' ' asMorph;
		addMorphBack: (SimpleButtonMorph new label: ' Disconnect all ';
				
				color: (Color red mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2;
				actionSelector: #value;
			
			target: [self disconnectAll.
					self updateConnectionButtons.
					]
				);
		addMorphBack: AlignmentMorph newVariableTransparentSpacer ! !

!RSLegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/28/2009 15:46'!
makeFieldBoundsPanel
| fieldBoundsText |
fieldBoundsText := self newTextMorph contents: '6'.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Robot 1 port: ' asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (fieldBoundsText)! !

!RSLegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 15:10'!
makeLegoConnectionPanelFor: nRobot
	legoPortsTexts at: nRobot put: (self newTextMorph contents: (5 + nRobot) asString).
	connectionButtons at: nRobot put: (SimpleButtonMorph new label: ' Connect ';
				
				color: (Color green mixed: 0.3 with: Color blue muchLighter);
				 borderColor: #raised; 
				 borderWidth: 2).
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: (('Lego #', nRobot asString, ': ') asMorph);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (legoPortsTexts at: nRobot);
		 addMorphBack: ('  ' asMorph);
		 addMorphBack: ((connectionButtons at: nRobot) actionSelector: #value;
			
			target: [(self isConnectedAt: nRobot)
					ifTrue: [self disconnectAt: nRobot]
					ifFalse: [self connectAt: nRobot].
					self updateConnectionButtons.
					])! !

!RSLegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 15:21'!
makeNRobotsPanel
	| nRobotsText |
	nRobotsText := numberOfRobots asString asMorph emphasis: 2.
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: 'Number of robots: ' asMorph;
		 addMorphBack: nRobotsText;
		 addMorphBack: ' ' asMorph;
		 addMorphBack: (SimpleButtonMorph new label: ' ... ';
			 color: self color;
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #changeNumberOfRobots;
			 target: self)! !

!RSLegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 17:51'!
makeTitle
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: (self asString asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer";
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)"! !

!RSLegoNxtMorph methodsFor: 'building' stamp: 'Richo 10/30/2009 15:32'!
newTextMorph
^TextMorph new autoFit: false;
extent: 50@23; borderWidth: 1; backgroundColor: Color white.! !

!RSLegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 15:05'!
numberOfRobots: aNumber
	numberOfRobots := aNumber.
	connectionButtons := Array new: numberOfRobots.
	legoPortsTexts := Array new: numberOfRobots.! !

!RSLegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/30/2009 17:53'!
robotServer
^robotServer ! !

!RSLegoNxtMorph methodsFor: 'private' stamp: 'Richo 10/28/2009 15:40'!
setRobotServer: aRSLegoNxtRobotServer 
robotServer := aRSLegoNxtRobotServer ! !

!RSLegoNxtMorph methodsFor: 'stepping' stamp: 'Richo 10/30/2009 15:20'!
step
self updateConnectionButtons ! !

!RSLegoNxtMorph methodsFor: 'stepping' stamp: 'Richo 10/30/2009 15:20'!
stepTime
^1000! !

!RSLegoNxtMorph methodsFor: 'updating' stamp: 'Richo 10/30/2009 15:12'!
updateConnectionButtons
1 to: numberOfRobots do: [:i|
	(self isConnectedAt: i)
	ifTrue: [
		(connectionButtons at: i) label: ' Disconnect ';							
							color: (Color red mixed: 0.3 with: Color blue muchLighter)
		]
	ifFalse: [
		(connectionButtons at: i) label: ' Connect ';							
							color: (Color green mixed: 0.3 with: Color blue muchLighter)
		]
	]
! !

AlignmentMorph subclass: #RSViewerMorph
	instanceVariableNames: 'board game plugins currentEnv controlPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Viewer'!

!RSViewerMorph class methodsFor: 'parts bin' stamp: 'Richo 10/13/2009 12:22'!
descriptionForPartsBin
	^ self
		partName: 'Robot Soccer Viewer'
		categories: #('Robot Soccer' )
		documentation: ''! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/18/2009 17:23'!
addPluginList

	plugins := (RSViewerPlugin allSubclasses asArray sort: [:a :b | a priority >= b priority])
				collect: [:each | each on: self].
	plugins
				do: [:each | self addMorphBack: each menu].! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:08'!
board
^board! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/26/2009 17:21'!
controlPanel
^controlPanel! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:25'!
currentEnv
^currentEnv ! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/18/2009 17:25'!
currentEnv: anEnvironment
currentEnv  := anEnvironment! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 23:50'!
delete
	controlPanel removeAll.
	super delete! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 12:08'!
game
^game! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/21/2009 13:48'!
gameState
	game isPaused ifTrue: [^#pause].
	game isStopped ifTrue: [^#stop].
	^#run! !

!RSViewerMorph methodsFor: 'accessing' stamp: 'Richo 10/13/2009 15:24'!
imagesHolder
^board imagesHolder! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/13/2009 10:51'!
initialize
	super initialize.
	self borderWidth: 2;
	color: ((Color
		r: 0.817
		g: 0.864
		b: 0.797)
		mixed: 0.75
		with: Color blue muchDarker);
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded.
	game := RSGame new.
	self initializeSubmorphs.
! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 17:43'!
initializeSubmorphs
	board := RSBoardMorph new.
	controlPanel := RSControlPanelMorph on: game.
	self addMorphBack: self makeTitle;
		 addMorphBack: controlPanel;
		 addMorphBack: board.
	
	self addPluginList! !

!RSViewerMorph methodsFor: 'initialize-release' stamp: 'Richo 10/26/2009 17:04'!
makeTitle
	^ AlignmentMorph newRow color: Color transparent;
		 cornerStyle: #rounded;
		 borderWidth: 0;
		 layoutInset: 3;
		 vResizing: #shrinkWrap;
		 wrapCentering: #center;
		 addMorphBack: ('Robot Soccer Viewer' asMorph font: Preferences windowTitleFont);
		 addMorphBack: AlignmentMorph newVariableTransparentSpacer;
		 addMorphBack: (SimpleButtonMorph new label: '  X  ';
			
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			 borderColor: #raised;
			 borderWidth: 2;
			 actionSelector: #delete;
			 target: self)! !

!RSViewerMorph methodsFor: 'stepping' stamp: 'Richo 10/30/2009 16:52'!
step
	board
		 gameState: (self gameState).
	currentEnv := game environment.
	currentEnv isNil
		ifTrue: [^ self].
	plugins
		do: [:each | each stepIfActive]. 
	board
		 draw: currentEnv! !

!RSViewerMorph methodsFor: 'stepping' stamp: 'Richo 10/13/2009 11:53'!
stepTime
^100! !

!TextDiffBuilder methodsFor: '*RobotSoccer' stamp: 'Richo 10/22/2010 15:27'!
split: aString by: splitChar
	| lines index nextIndex |
	lines := OrderedCollection new.
	index := 1.
	[index <= aString size] whileTrue:[
		nextIndex := aString 
						indexOf: splitChar 
						startingAt: index 
						ifAbsent:[aString size+1].
		lines add: (aString copyFrom: index to: nextIndex-1).
		index := nextIndex+1].
	^lines! !

TestCase subclass: #RSAngleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual1
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle degrees: 45.
	self
		should: [a1 = a2].
	self
		shouldnt: [a1
				= (RSAngle degrees: 46)]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual2
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle radians: 0.785398163397448.
	self
		should: [a1 = a2].
	self
		shouldnt: [a1
				= (RSAngle radians: 1)]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual3
	| a1 a2 |
	a1 := RSAngle radians: 0.785398163397448.
	a2 := RSAngle degrees: 45.
	self
		should: [a1 = a2]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual4
	| a1 a2 |
	a1 := RSAngle radians: 0.785398163397448.
	a2 := RSAngle radians: 0.78539817.
	self
		should: [a1 = a2]! !

!RSAngleTest methodsFor: 'igual' stamp: 'Richo 6/21/2008 20:02'!
testIgual5
	| a1 a2 |
	a1 := RSAngle degrees: 45.005.
	a2 := RSAngle degrees: 45.004.
	self
		should: [a1 = a2]! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:04'!
testInicializacionGrados
	| a |
	a := RSAngle degrees: 45.
	self
		should: [a degrees = 45].
	self
		should: [a radians closeTo: 0.785398163397448].
! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:05'!
testInicializacionGrados2
	| a |
	a := RSAngle degrees: -45.
	self
		should: [a degrees = -45].
	self
		should: [a radians closeTo: -0.785398163397448].
! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:05'!
testInicializacionRadianes
	| a |
	a := RSAngle radians: 0.785398163397448.
	self
		should: [a degrees closeTo: 45].
	self
		should: [a radians closeTo: 0.785398163397448].
! !

!RSAngleTest methodsFor: 'inicializacion' stamp: 'Richo 6/21/2008 20:05'!
testInicializacionRadianes2
	| a |
	a := RSAngle radians: -0.785398163397448.
	self
		should: [a degrees closeTo: -45].
	self
		should: [a radians closeTo: -0.785398163397448].
! !

!RSAngleTest methodsFor: 'negated' stamp: 'Richo 6/21/2008 20:02'!
testNegated
	| a |
	a := RSAngle degrees: 45.
	self
		should: [a negated degrees closeTo: -45].
	self
		should: [a negated radians closeTo: -0.785398163397448]! !

!RSAngleTest methodsFor: 'negated' stamp: 'Richo 6/21/2008 20:02'!
testNegated2
	| a |
	a := RSAngle degrees: 180.
	self
		should: [a negated degrees closeTo: -180].
	self
		should: [a negated radians closeTo: -3.141592653589793]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:03'!
testOpuesto
	| a |
	a := RSAngle degrees: 90.
	self
		should: [a opposite
				= (RSAngle degrees: -90)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:03'!
testOpuesto2
	| a |
	a := RSAngle degrees: 45.
	self
		should: [a opposite
				= (RSAngle degrees: -135)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:04'!
testOpuesto3
	| a |
	a := RSAngle degrees: 15.
	self
		should: [a opposite
				= (RSAngle degrees: -165)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'opuesto' stamp: 'Richo 6/21/2008 20:04'!
testOpuesto4
	| a |
	a := RSAngle degrees: 0.
	self
		should: [a opposite
				= (RSAngle degrees: 180)].
	self
		shouldnt: [a opposite
				= (RSAngle degrees: -91)]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:02'!
testResta1
	| a1 a2 |
	a1 := RSAngle degrees: 179.
	a2 := RSAngle degrees: -2.
	self
		should: [(a1 - a2) degrees = -179]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta2
	| a1 a2 |
	a1 := RSAngle degrees: 135.
	a2 := RSAngle degrees: -180.
	self
		should: [(a1 - a2) degrees = -45]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta3
	| a1 a2 |
	a1 := RSAngle degrees: -135.
	a2 := RSAngle degrees: -180.
	self
		should: [(a1 - a2) degrees = 45]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta4
	| a1 a2 |
	a1 := RSAngle degrees: -30.
	a2 := RSAngle degrees: 10.
	self
		should: [(a1 - a2) degrees = -40]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta5
	| a1 a2 |
	a1 := RSAngle degrees: 10.
	a2 := RSAngle degrees: -30.
	self
		should: [(a1 - a2) degrees = 40]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta6
	| a1 a2 |
	a1 := RSAngle degrees: -10.
	a2 := RSAngle degrees: 30.
	self
		should: [(a1 - a2) degrees = -40]! !

!RSAngleTest methodsFor: 'resta' stamp: 'Richo 6/21/2008 20:03'!
testResta7
	| a1 a2 |
	a1 := RSAngle degrees: -45.
	a2 := RSAngle degrees: 0.
	self
		should: [(a1 - a2) degrees = -45]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma1
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle degrees: 90.
	self
		should: [(a1 + a2) degrees = 135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma2
	| a1 a2 |
	a1 := RSAngle degrees: 135.
	a2 := RSAngle degrees: 90.
	self
		should: [(a1 + a2) degrees = -135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma3
	| a1 a2 |
	a1 := RSAngle degrees: 45.
	a2 := RSAngle degrees: 180.
	self
		should: [(a1 + a2) degrees = -135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma4
	| a1 a2 |
	a1 := RSAngle degrees: -45.
	a2 := RSAngle degrees: 180.
	self
		should: [(a1 + a2) degrees = 135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma5
	| a1 a2 |
	a1 := RSAngle degrees: -45.
	a2 := RSAngle degrees: -180.
	self
		should: [(a1 + a2) degrees = 135]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma6
	| a1 a2 |
	a1 := RSAngle degrees: -179.
	a2 := RSAngle degrees: -2.
	self
		should: [(a1 + a2) degrees = 179]! !

!RSAngleTest methodsFor: 'suma' stamp: 'Richo 6/21/2008 20:03'!
testSuma7
	| a1 a2 |
	a1 := RSAngle degrees: 0.
	a2 := RSAngle degrees: 45.
	self
		should: [(a1 + a2) degrees = 45]! !

TestCase subclass: #RSEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSEnvironmentTest methodsFor: 'as yet unclassified' stamp: 'Richo 3/31/2009 16:22'!
testShouldDecideTeam
	| env home opponent currentBall lastBall |
	env := RSEnvironment new.
	home := Array new: 5.
	opponent := Array new: 5.
	1
		to: 5
		do: [:i | 
			home
				at: i
				put: (RSRobot new environment: env).
			opponent at: i put: RSOpponentRobot new].
	currentBall := RSBall new.
	lastBall := RSBall new.
	env home: home;
		 opponent: opponent;
		 currentBall: currentBall;
		 lastBall: lastBall.
	! !

TestCase subclass: #RSRobotExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 10 @ 10.
	self
		should: [ang degrees closeTo: 45]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo2
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 10 @ 0.
	self
		should: [ang degrees closeTo: 0]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo3
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 0 @ 10.
	self
		should: [ang degrees closeTo: 90]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo4
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: -10 @ -10.
	self
		should: [ang degrees closeTo: -135]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo5
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: -10 @ 10.
	self
		should: [ang degrees closeTo: 135]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo6
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: 0 @ -10.
	self
		should: [ang degrees closeTo: -90]! !

!RSRobotExampleTest methodsFor: 'calcularAngulo' stamp: 'Richo 6/22/2008 22:20'!
testCalcularAngulo7
	| robot ang |
	robot := RSRobotExample new.
	ang := robot getAngle: -10 @ 0.
	self
		should: [ang degrees closeTo: 180]! !

!RSRobotExampleTest methodsFor: 'cuadranteDe' stamp: 'Richo 6/22/2008 22:20'!
testCuadranteDe
	| robot cuadrante |
	robot := RSRobotExample new.
	robot position: 0 @ 0.
	cuadrante := robot quadrant: 10 @ 10.
	self
		should: [cuadrante = 1].
	cuadrante := robot quadrant: -10 @ 10.
	self
		should: [cuadrante = 2].
	cuadrante := robot quadrant: -10 @ -10.
	self
		should: [cuadrante = 3].
	cuadrante := robot quadrant: 10 @ -10.
	self
		should: [cuadrante = 4]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado10
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado11
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	obj := 10 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado12
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 135).
	robot position: 0 @ 0.
	obj := 10 @ -1.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado13
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -135).
	robot position: 0 @ 0.
	obj := 10 @ -1.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado14
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado15
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 0).
	robot position: 0 @ 0.
	obj := 0 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:20'!
testEstaDelLado2
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado3
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado4
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado5
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -90).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado6
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	obj := 0 @ 10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado7
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -90).
	robot position: 0 @ 0.
	obj := 10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado8
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: -45).
	robot position: 0 @ 0.
	obj := 0 @ -10.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		should: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'estaDelLado' stamp: 'Richo 6/22/2008 22:21'!
testEstaDelLado9
	| robot obj |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 135).
	robot position: 0 @ 0.
	obj := -10 @ 0.
	self
		shouldnt: [robot isLookingTo: obj].
	self
		shouldnt: [robot isInTheRightSide: obj]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 10].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA10
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: -10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA2
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA3
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoA4
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	self
		should: [robot isLookingTo: 0 @ -10].
	self
		should: [robot isLookingTo: 0 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA1
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA2
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: -10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA3
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA4
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: 10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeEspaldasA5
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookBackwardsTo: -10 @ 0].
	self
		shouldnt: [robot lookBackwardsTo: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 45).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 10].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA10
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 179).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: -10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA2
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:21'!
testMirandoDeFrenteA3
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 1).
	robot position: 0 @ 0.
	self
		should: [robot lookInFrontOf: 10 @ 0].
	self
		shouldnt: [robot lookInFrontOf: -10 @ 10]! !

!RSRobotExampleTest methodsFor: 'mirandoA' stamp: 'Richo 6/22/2008 22:22'!
testMirandoDeFrenteA4
	| robot |
	robot := RSRobotExample new.
	robot
		rotation: (RSAngle degrees: 90).
	robot position: 0 @ 0.
	self
		shouldnt: [robot lookInFrontOf: 0 @ -10].
	self
		should: [robot lookInFrontOf: 0 @ 10]! !

TestCase subclass: #RSViewerMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RobotSoccer-Tests'!

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion
	| angSimu angSqueak |
	angSimu := 90.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = 0]! !

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion2
	| angSimu angSqueak |
	angSimu := 0.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = 90]! !

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion3
	| angSimu angSqueak |
	angSimu := -179.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = -91]! !

!RSViewerMorphTest methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2008 22:10'!
testAngleConversion4
	| angSimu angSqueak |
	angSimu := 179.
	angSqueak := RSBoardMorph squeakAngle: angSimu.
	self
		should: [angSqueak = -89]! !
